{   This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   ---------------------------------------------------------------------------

    Author : Luc DAVID Email: luckylazarus@free.fr
    2006 - 2008

   --------------------------------------------------------------------------- }

unit SQLitePassDboTest;
 {$IFDEF FPC}
  {$mode DELPHI}
 {$ENDIF}
interface

uses

  {$IFDEF WIN32}
  Windows,
  {$ENDIF}

  {$IFDEF FPC}
  LResources,
  {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, {Commctrl,}
  Grids, DBGrids, Db, StdCtrls, ComCtrls, ExtCtrls, DBCtrls, SqlitePassDbo,
  ExtDlgs, ActnList, Menus, Buttons, ImgList, SqlitePassUtils;

Const
 MenuDatabaseItemsCount = 18;
 MaxMRUFilesCount = 6;

type
  { TMainForm }

  TMainForm = class(TForm)
    Tv: TTreeView;
    StatusBar: TStatusBar;
    PanelDatabaseToolBar: TPanel;
    Panel2: TPanel;
    PageControl: TPageControl;
    TsDatabase: TTabSheet;
    TsDataset: TTabSheet;
    DataSource: TDataSource;
    OpenPictureDialog: TOpenPictureDialog;
    SavePictureDialog: TSavePictureDialog;
    MainMenu: TMainMenu;
    MainActionList: TActionList;
    ActionApplicationQuit: TAction;
    OpenFileDialog: TOpenDialog;
    Database: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    MenuSeparator1: TMenuItem;
    Quit1: TMenuItem;
    SaveFileDialog: TSaveDialog;
    Label18: TLabel;
    TsSQL: TTabSheet;
    PageControlDataset: TPageControl;
    TsDatasetStructure: TTabSheet;
    TsDatasetData: TTabSheet;
    Panel3: TPanel;
    DBImage: TDBImage;
    BtLoadPictureFromFile: TSpeedButton;
    BtClearPicture: TSpeedButton;
    BtSavePictureToFile: TSpeedButton;
    DBMemo: TDBMemo;
    ComboBoxGraphicFields: TComboBox;
    CbShowGraphic: TCheckBox;
    CbShowMemo: TCheckBox;
    BtLoadMemoFromFile: TSpeedButton;
    BtClearMemo: TSpeedButton;
    BtSaveMemoToFile: TSpeedButton;
    ComboBoxMemoFields: TComboBox;
    PanelNoRecordFound: TPanel;
    DBGridDatasetData: TDBGrid;
    Help1: TMenuItem;
    ActionApplicationShowAbout: TAction;
    ActionShowAbout1: TMenuItem;
    CreateaNewdatabase1: TMenuItem;
    N1: TMenuItem;
    Refreshdatabaseinformation1: TMenuItem;
    Compactsize1: TMenuItem;
    CheckdatabaseIntegrity1: TMenuItem;
    N2: TMenuItem;
    StartTransaction1: TMenuItem;
    CommitTransaction1: TMenuItem;
    RollbackTransaction1: TMenuItem;
    TsDatasetIndexes: TTabSheet;
    PanelIndexesToolBar: TPanel;
    PanelIndexMain: TPanel;
    PanelAvailableIndexes: TPanel;
    LabelIndexAvailable: TLabel;
    ListBoxIndexDefs: TListBox;
    PanelIndexRight: TPanel;
    MemoSQLIndexCreateStmt: TMemo;
    ScrollBoxIndexedFields: TScrollBox;
    PanelFieldsUsedByIndex: TPanel;
    Splitter1: TSplitter;
    LabelIndexFieldsUsed: TLabel;
    PanelIndexApplyChanges: TPanel;
    SbApplyIndexChanges: TSpeedButton;
    SbCancelIndexChanges: TSpeedButton;
    PanelIndexCreateStmt: TPanel;
    Label21: TLabel;
    Image4: TImage;
    Image5: TImage;
    Panel1: TPanel;
    Label22: TLabel;
    Image10: TImage;
    ImageIndexDirectionDesc: TImage;
    ImageIndexDirectionAsc: TImage;
    ImageIndexDirectionUnknown: TImage;
    ActionListDatabase: TActionList;
    ActionDatabaseCreateNew: TAction;
    ActionDatabaseOpen: TAction;
    ActionDatabaseRefresh: TAction;
    ActionDatabaseClose: TAction;
    ActionDatabaseAttach: TAction;
    ActionDatabaseCheckIntegrity: TAction;
    ActionDatabaseCompactSize: TAction;
    PanelSqlStmt: TPanel;
    PanelSqlResult: TPanel;
    Splitter2: TSplitter;
    Panel6: TPanel;
    LabelSQLStmt: TLabel;
    Image1: TImage;
    Panel7: TPanel;
    Label24: TLabel;
    Image2: TImage;
    Panel8: TPanel;
    SbRunSQL: TSpeedButton;
    MemoSqlStmt: TMemo;
    ActionShowSQLPage: TAction;
    ActionDatabaseTransactionStart: TAction;
    ActionDatabaseTransactionCommit: TAction;
    ActionDatabaseTransactionRollback: TAction;
    DBGridSqlDirect: TDBGrid;
    DBNavigator2: TDBNavigator;
    DsSQLDirect: TDataSource;
    ActionDatabaseDetach: TAction;
    Attachadatabase1: TMenuItem;
    Detachadatabase1: TMenuItem;
    N3: TMenuItem;
    Panel9: TPanel;
    DBNavDataset: TDBNavigator;
    ImageDatasetReadOnly: TImage;
    LabelDatasetReadOnly: TLabel;
    Splitter: TSplitter;
    PanelDatasetToolbar: TPanel;
    ActionListDataset: TActionList;
    CheckBoxUniqueIndex: TCheckBox;
    Image7: TImage;
    ActionDatasetShowSortDialog: TAction;
    ActionDatasetFilterOnSelection: TAction;
    ActionDatasetShowLocateDialog: TAction;
    ActionDatasetLocateFirst: TAction;
    ActionDatasetLocateNext: TAction;
    ActionDatasetLocatePrior: TAction;
    ActionDatasetLocateLast: TAction;
    ActionDatasetShowFilterDialog: TAction;
    ActionDatasetFilterOnOff: TAction;
    SbDatabaseOpen: TSpeedButton;
    SbDatabaseClose: TSpeedButton;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    SbDatabaseTransactionStart: TSpeedButton;
    SbDatabaseTransactionCommit: TSpeedButton;
    SbDatabaseTransactionRollback: TSpeedButton;
    Bevel10: TBevel;
    SbDatabaseShowSQLPage: TSpeedButton;
    SbIndexRefresh: TSpeedButton;
    SbIndexRename: TSpeedButton;
    SbIndexCreateNew: TSpeedButton;
    Bevel11: TBevel;
    Bevel12: TBevel;
    SbIndexDelete: TSpeedButton;
    ActionListIndexes: TActionList;
    ActionIndexCreateNew: TAction;
    ActionIndexRefresh: TAction;
    ActionIndexRename: TAction;
    ActionIndexDelete: TAction;
    Bevel13: TBevel;
    SbDatasetShowSortDialog: TSpeedButton;
    SbDatasetFilterOnSelection: TSpeedButton;
    SbDatasetShowFilterDialog: TSpeedButton;
    Bevel14: TBevel;
    SbDatasetLocatePrior: TSpeedButton;
    Bevel15: TBevel;
    SbDatasetShowLocateDialog: TSpeedButton;
    Bevel16: TBevel;
    Bevel17: TBevel;
    SbDatasetFilterOnOff: TSpeedButton;
    SbDatasetLocateFirst: TSpeedButton;
    SbDatasetLocateLast: TSpeedButton;
    SbDatasetLocateNext: TSpeedButton;
    Bevel18: TBevel;
    LabelLocateRecordCount: TLabel;
    Panel5: TPanel;
    LabelCacheSize: TLabel;
    Label1: TLabel;
    LabelDbType: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    LabelDbFileSize: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    LabelDbComponentVersion: TLabel;
    Label11: TLabel;
    LabelDbSqliteLibVersion: TLabel;
    Label13: TLabel;
    LabelDbVersion: TLabel;
    Label15: TLabel;
    LabelDbKexiVersion: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label25: TLabel;
    EditDbCacheSize: TEdit;
    EditDbQueryTimeout: TEdit;
    CbDbReadOnly: TCheckBox;
    CbDbShowSystemObjects: TCheckBox;
    CBDbSmartOpen: TCheckBox;
    EditDbUserTag: TEdit;
    EditDbDefaultCacheSize: TEdit;
    CbDbCountChanges: TCheckBox;
    CbDbCaseSensitiveLike: TCheckBox;
    CbDbEmptyResultCallback: TCheckBox;
    CbDbFullColumnName: TCheckBox;
    EditDbPageSize: TEdit;
    EditDbEncoding: TEdit;
    Panel21: TPanel;
    SbDbApplyChanges: TSpeedButton;
    SbDbCancelChanges: TSpeedButton;
    EditDbTemporaryStorage: TEdit;
    EditDbSynchronous: TEdit;
    GridAttachedDatabases: TStringGrid;
    Panel34: TPanel;
    Bevel20: TBevel;
    Bevel21: TBevel;
    SbDatabaseRefresh: TSpeedButton;
    SbDatabaseCompactSize: TSpeedButton;
    SbDatabaseCheckIntegrity: TSpeedButton;
    Bevel9: TBevel;
    CbMRUFiles: TComboBox;
    LabelRecordCount: TLabel;
    ActionDatabaseShowErrorLog: TAction;
    Showdatabaseerrorlog1: TMenuItem;
    N4: TMenuItem;
    ActionDatasetRefresh: TAction;
    SbDatasetRefresh: TSpeedButton;
    Bevel19: TBevel;
    Bevel22: TBevel;
    ActionDatabaseShowFieldTypesTranslationRules: TAction;
    Options1: TMenuItem;
    N5: TMenuItem;
    FieldTypesTranslationrules1: TMenuItem;
    ActionDatabaseShowCustomFieldDefs: TAction;
    CustomFieldDefs1: TMenuItem;
    ActionListTables: TActionList;
    ActionTableCreateNew: TAction;
    Tables1: TMenuItem;
    Createanewtable1: TMenuItem;
    TsFieldDefs: TTabSheet;
    Panel31: TPanel;
    Panel10: TPanel;
    ScrollBarHorizontal: TScrollBar;
    ScrollBoxFieldDefsPropertiesValues: TScrollBox;
    Panel32: TPanel;
    ScrollboxFieldDefsFieldNames: TScrollBox;
    Panel33: TPanel;
    ScrollBoxFieldDefsPropertiesNames: TScrollBox;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel30: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Panel29: TPanel;
    ScrollBarVertical: TScrollBar;
    PanelFieldDefs: TPanel;
    Label16: TLabel;
    Image9: TImage;
    ImageCheck: TImage;
    Image11: TImage;
    PanelCreateStmt: TPanel;
    PanelSqlCreateStmt: TPanel;
    Label20: TLabel;
    Image6: TImage;
    MemoSqlCreateStmt: TMemo;
    PanelDefaultSelectStmt: TPanel;
    MemoSqlSelectStmt: TMemo;
    PanelSqlSelectStatement: TPanel;
    Label2: TLabel;
    Image8: TImage;
    Splitter3: TSplitter;
    ActionTableModify: TAction;
    ModifyTable1: TMenuItem;
    ActionTableDelete: TAction;
    ActionTableRename: TAction;
    ActionTableEmpty: TAction;
    RenameTable1: TMenuItem;
    N6: TMenuItem;
    EmptyTable1: TMenuItem;
    DeleteTable1: TMenuItem;
    ActionTableReindex: TAction;
    PopupMenuTables: TPopupMenu;
    Createanewtable2: TMenuItem;
    ModifyTable2: TMenuItem;
    RenameTable2: TMenuItem;
    N7: TMenuItem;
    EmptyTable2: TMenuItem;
    DeleteTable2: TMenuItem;
    ReindexTable1: TMenuItem;
    ReindexTable2: TMenuItem;
    PopupMenuDatabase: TPopupMenu;
    CreateaNewdatabase2: TMenuItem;
    Createanewtable3: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Refreshdatabaseinformation2: TMenuItem;
    CompactSize2: TMenuItem;
    CheckdatabaseIntegrity2: TMenuItem;
    ActionListQueries: TActionList;
    ActionQueryCreateNew: TAction;
    ActionQueryModify: TAction;
    ActionQueryDelete: TAction;
    ActionQueryRename: TAction;
    PopupMenuQueries: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem7: TMenuItem;
    Label4: TLabel;
    Shape1: TShape;
    Shape6: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape7: TShape;
    Shape8: TShape;
    SbDatabaseAttach: TSpeedButton;
    SbDatabaseDetach: TSpeedButton;
    CbDbVacuumType: TComboBox;
    Label27: TLabel;
    Shape9: TShape;
    SbSaveSQLToDatabase: TSpeedButton;
    SbSaveSQLToFile: TSpeedButton;
    SbLoadSQLfromFile: TSpeedButton;
    LabelSQLStmtName: TLabel;
    ActionListSQLStmts: TActionList;
    ActionSQLStmtCreateNew: TAction;
    ActionSQLStmtDelete: TAction;
    ActionSQLStmtRename: TAction;
    PopupMenuSQLStmts: TPopupMenu;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    CreateanewSQLstatement1: TMenuItem;
    RenameSQLStatement1: TMenuItem;
    CreateanewSQLstatement2: TMenuItem;
    ActionTableSaveAsView: TAction;
    N10: TMenuItem;
    SaveTableasView1: TMenuItem;
    SbSaveSQLAsView: TSpeedButton;
    N11: TMenuItem;
    SaveTableasView2: TMenuItem;
    Queries1: TMenuItem;
    SQL1: TMenuItem;
    Views1: TMenuItem;
    Triggers1: TMenuItem;
    CreateanewSQLstatement3: TMenuItem;
    RenameSQLStatement2: TMenuItem;
    N12: TMenuItem;
    DeleteSQLstatement1: TMenuItem;
    ActionListViews: TActionList;
    ActionViewCreateNew: TAction;
    ActionViewDelete: TAction;
    ActionViewRename: TAction;
    ActionSQLExecute: TAction;
    PopupMenuViews: TPopupMenu;
    MenuItem8: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    RenameView1: TMenuItem;
    CreateanewView1: TMenuItem;
    RenameView2: TMenuItem;
    N13: TMenuItem;
    DeleteView1: TMenuItem;
    ActionListTriggers: TActionList;
    ActionTriggerCreateNew: TAction;
    ActionTriggerDelete: TAction;
    ActionTriggerRename: TAction;
    PopupMenuTriggers: TPopupMenu;
    MenuItem4: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    SbClosePanelSQLResult: TSpeedButton;
    TreeViewImageList: TImageList;
    Shape10: TShape;
    Shape11: TShape;
    ImageList: TImageList;
    ImageListEnabled: TImageList;
    ImageListDisabled: TImageList;
    Bevel1: TBevel;
    ActionTriggerModify: TAction;
    ActionViewModify: TAction;
    ModifyTable3: TMenuItem;
    ActionSQLStmtModify: TAction;
    CompactSize3: TMenuItem;
    ModifyQuery1: TMenuItem;
    RenameQuery1: TMenuItem;
    N14: TMenuItem;
    DeleteQuery1: TMenuItem;
    N15: TMenuItem;
    Indexes1: TMenuItem;
    PopupMenuIndexes: TPopupMenu;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    PopupMenuDatasets: TPopupMenu;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    N16: TMenuItem;
    LocateNext1: TMenuItem;
    LocateLast1: TMenuItem;
    N17: TMenuItem;
    Refresh1: TMenuItem;
    CreateanewQuery1: TMenuItem;
    CreateanewView2: TMenuItem;
    CreateanewTrigger1: TMenuItem;
    N18: TMenuItem;
    SQL2: TMenuItem;
    procedure CbDbReadOnlyChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TvChange(Sender: TObject; Node: TTreeNode);
    procedure BtLoadPictureFromFileClick(Sender: TObject);
    procedure BtClearPictureClick(Sender: TObject);
    procedure BtSavePictureToFileClick(Sender: TObject);
    procedure ActionDatabaseOpenExecute(Sender: TObject);
    procedure CbShowGraphicClick(Sender: TObject);
    procedure CbShowMemoClick(Sender: TObject);
    procedure BtLoadMemoFromFileClick(Sender: TObject);
    procedure BtClearMemoClick(Sender: TObject);
    procedure BtSaveMemoToFileClick(Sender: TObject);
    procedure ComboBoxGraphicFieldsChange(Sender: TObject);
    procedure ActionDatabaseCloseExecute(Sender: TObject);
    procedure DbSettingChanged(Sender: TObject);
    procedure SbDbCancelChangesClick(Sender: TObject);
    procedure ActionApplicationQuitExecute(Sender: TObject);
    procedure ActionDatabaseRefreshExecute(Sender: TObject);
    procedure ListBoxIndexDefsClick(Sender: TObject);
    procedure ActionApplicationShowAboutExecute(Sender: TObject);
    procedure ActionDatabaseCompactSizeExecute(Sender: TObject);
    procedure ActionIndexCreateNewExecute(Sender: TObject);
    procedure ActionIndexDeleteExecute(Sender: TObject);
    procedure ActionIndexRefreshExecute(Sender: TObject);
    procedure ActionShowSQLPageExecute(Sender: TObject);
    procedure ActionDatabaseTransactionStartExecute(Sender: TObject);
    procedure ActionDatabaseTransactionCommitExecute(Sender: TObject);
    procedure ActionDatabaseTransactionRollbackExecute(Sender: TObject);
    procedure ActionIndexRenameExecute(Sender: TObject);
    procedure ActionDatabaseAttachExecute(Sender: TObject);
    procedure ActionDatabaseDetachExecute(Sender: TObject);
    procedure DBGridDatasetDataTitleClick(Column: TColumn);
    procedure ActionDatasetShowSortDialogExecute(Sender: TObject);
    procedure ComboBoxMemoFieldsChange(Sender: TObject);
//    procedure TsDatasetIndexesShow(Sender: TObject);
    procedure SbCancelIndexChangesClick(Sender: TObject);
    procedure CheckBoxUniqueIndexClick(Sender: TObject);
    procedure ScrollBarVerticalScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBoxFieldDefsPropertiesValuesResize(Sender: TObject);
    procedure ScrollBarHorizontalScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure ActionDatasetFilterOnSelectionExecute(Sender: TObject);
    procedure ActionDatasetFilterOnSelectionUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionDatasetShowLocateDialogExecute(Sender: TObject);
    procedure ActionDatasetLocateFirstExecute(Sender: TObject);
    procedure ActionDatasetLocateNextExecute(Sender: TObject);
    procedure ActionDatasetLocatePriorExecute(Sender: TObject);
    procedure ActionDatasetLocateLastExecute(Sender: TObject);
    procedure ActionDatasetShowFilterDialogExecute(Sender: TObject);
    procedure ActionDatasetFilterOnOffExecute(Sender: TObject);
    procedure CbMRUFilesClick(Sender: TObject);
    procedure ActionDatabaseShowErrorLogExecute(Sender: TObject);
    procedure ActionDatasetRefreshExecute(Sender: TObject);
    procedure ActionDatabaseShowFieldTypesTranslationRulesExecute(Sender: TObject);
    procedure ActionDatabaseShowCustomFieldDefsExecute(Sender: TObject);
    procedure ActionDatabaseCreateNewExecute(Sender: TObject);
    procedure ActionTableCreateNewExecute(Sender: TObject);
    procedure ActionTableModifyExecute(Sender: TObject);
    procedure ActionTableRenameExecute(Sender: TObject);
    procedure ActionTableReindexExecute(Sender: TObject);
    procedure ActionTableDeleteExecute(Sender: TObject);
    procedure TsDatabaseShow(Sender: TObject);
    procedure CbDbShowSystemObjectsClick(Sender: TObject);
    procedure SbDbApplyChangesClick(Sender: TObject);
    procedure EditDbQueryTimeoutKeyPress(Sender: TObject; var Key: Char);
    procedure ActionTableEmptyExecute(Sender: TObject);
    procedure SbSaveSQLToDatabaseClick(Sender: TObject);
    procedure ActionSQLStmtCreateNewExecute(Sender: TObject);
    procedure ActionSQLStmtDeleteExecute(Sender: TObject);
    procedure ActionSQLStmtRenameExecute(Sender: TObject);
    procedure ActionTableSaveAsViewExecute(Sender: TObject);
    procedure SbSaveSQLAsViewClick(Sender: TObject);
    procedure ActionViewCreateNewExecute(Sender: TObject);
    procedure ActionViewDeleteExecute(Sender: TObject);
    procedure SbSaveSQLToFileClick(Sender: TObject);
    procedure SbLoadSQLfromFileClick(Sender: TObject);
    procedure ActionSQLExecuteExecute(Sender: TObject);
    procedure SbClosePanelSQLResultClick(Sender: TObject);
    procedure ActionDatabaseCheckIntegrityExecute(Sender: TObject);
    procedure PopupMenusPopup(Sender: TObject);    
  private
    DialogFilterString: String;
    MRUFileList: TStringList;
    ToolboxDbAvailable: Boolean;
    ActionsNeedUpdate: Boolean;

    { Display utility }
    {$IFNDEF FPC}
    Procedure InitMenuImages;
    function GetMenuItemImage(MenuItem: TMenuItem): Boolean;
    Procedure RefreshMenuImages;
    {$ENDIF}
    Procedure InitToolbarImages;
    Procedure RefreshActions;
    Procedure RefreshStatusBar;
    procedure RefreshTreeView(NodeCaption: String = '');
    procedure TreeViewSelectByName(ItemName: String);

    { --- Indexes --- }
    procedure RefreshIndexList;
    procedure RefreshIndexInfos(CurrentIndex: TSqlitePassIndex);
    procedure RefreshIndexSpeedButtons(Enable: Boolean);
    procedure OnCbIndexedFieldClick(Sender: TObject);
    procedure OnImIndexDirectionClick(Sender: TObject);

    { --- Database --- }
    procedure OpenDatabaseFile(FileName: String = '');
    procedure ShowDatabaseInfos;
    function DatabaseTypeAsString: String;
    function DatabaseAutoVaccumAsString: String;
    function DatabaseEncodingAsString: String;

    { --- Datasets --- }
    procedure ShowDatasetInfos(Node: TTreeNode);

    { MRU Files }
    procedure LoadMRUFiles;
    procedure SaveMRUFiles;
    procedure AddNewMRUFile(FileName: String);
    procedure MRUFileOpen(Sender: TObject);
    procedure UpdateMRUFiles;

    { Idle Handler }
    procedure ApplicationIdleHandler(Sender: TObject; var Done: Boolean);
  public
    { Db and Dataset selected by user }
    Db: TSqlitePassDatabase;
    Dataset: TSqlitePassDataset;

    { Dataset used to execute direct SQL on user demand }
    SQLDirectDataset: TSqlitePassDataset;

    { Db and Dataset to store program settings }
    DbSettings: TSqlitePassDatabase;
    DatasetSettings: TSqlitePassDataset;

    { TList to display Indexes information }
    CbIndexedFields: TList;
    ImIndexDirection: TList;

    { TList to display FieldDefs information }
    ListofPanelFieldDefProperties: TList;
    ListofPanelFieldDefFieldNames: TList;

    DatabaseNode, TablesNode, QueriesNode, ViewsNode, TriggersNode, SystemTablesNode,
    SQLNode, SQLCreateNode, SQLCreateTableNode, SQLSelectNode, SQLInsertNode,
    SQLUpdateNode, SQLDeleteNode, SQLOthersNode: TTreeNode;
  end;


  { Panels to display FieldDefs information }
  TPanelFieldDefPropertiesValues = class;

  TPanelFieldDefPropertyValue = Class(TPanel)
  Public
  constructor Create(AOwner: TPanel); reintroduce;
  constructor CreateAtPos(AOwner: TPanel; Top, Left: Integer); virtual;
  end;

  TPanelFieldDefTitle = Class(TPanel)
  Public
  constructor Create(AOwner: TComponent); Reintroduce;
  constructor CreateAtPos(AOwner: TComponent; Top, Left: Integer); virtual;
  end;

  TPanelFieldDefBooleanPropertyValue = Class(TPanelFieldDefPropertyValue)
  Private
  FImage: TImage;
    FValue: Boolean;
    procedure SetFValue(const Value: Boolean);
  Public
  Property Value: Boolean Read FValue Write SetFValue;
  constructor CreateAtPos(AOwner: TPanelFieldDefPropertiesValues; Top, Left: Integer); reintroduce;
  destructor Destroy; Override;
  end;

  TPanelFieldDefPropertiesValues = Class(TPanel)
  Private
  FLeft: Integer;
  Protected
  FTop: Integer;
  FVOffset: Integer;
  FDataType: TPanelFieldDefPropertyValue;
  FAutoInc: TPanelFieldDefBooleanPropertyValue;
  FDefaultValue: TPanelFieldDefPropertyValue;
  FDisplayName: TPanelFieldDefPropertyValue;
  FFieldNo: TPanelFieldDefPropertyValue;
  FFieldFullName: TPanelFieldDefPropertyValue;
  FForeignKey: TPanelFieldDefBooleanPropertyValue;
  FHint: TPanelFieldDefPropertyValue;
  FIndexed: TPanelFieldDefBooleanPropertyValue;
  FInternalPrimaryKey: TPanelFieldDefBooleanPropertyValue;
  FNativeDataType: TPanelFieldDefPropertyValue;
  FNativeDataTypeCode: TPanelFieldDefPropertyValue;
  FNotEmpty: TPanelFieldDefBooleanPropertyValue;
  FNoConstraints: TPanelFieldDefBooleanPropertyValue;
  FNotNull: TPanelFieldDefBooleanPropertyValue;
  FPrecision: TPanelFieldDefPropertyValue;
  FPrimaryKey: TPanelFieldDefBooleanPropertyValue;
  FSize: TPanelFieldDefPropertyValue;
  FUnique: TPanelFieldDefBooleanPropertyValue;
  public
  constructor Create(AOwner: TComponent); override;
  constructor CreateAtPos(AOwner: TComponent; Top, Left: Integer);
  destructor Destroy; Override;
  end;

var
  MainForm: TMainForm;

implementation

 {$IFNDEF FPC}
  {$R *.DFM}
 {$ENDIF}
 
Uses SqlitePassSortByDialog, CreateNewIndex, RenameItem,
  SqlitePassLocateDialog, SqlitePassFiltersDialog, SqlitePassErrorLogDialog,
  SqlitePassDataTypesDialog, SqlitePassCustomFieldDefsDialog,
  SqlitePassCreateNewDatabaseDialog, SqlitePassCreateTableDialog;


{ Creates / Destroys the Main Form }

procedure TMainForm.FormCreate(Sender: TObject);
begin
CbIndexedFields:= TList.Create;
ImIndexDirection:= TList.Create;
ListofPanelFieldDefProperties := TList.Create;
ListofPanelFieldDefFieldNames := TList.Create;

{ Db and Dataset to store program settings }
DbSettings := TSqlitePassDatabase.Create(Self);
DbSettings.Database := 'SQLiteToolbox.db3';
DatasetSettings := TSqlitePassDataset.Create(Self);
DatasetSettings.Database := DbSettings;

{ Db and Dataset selected by user }
Db := TSqlitePassDatabase.Create(Self);
Db.Options.LogErrors := True;
Dataset := TSqlitePassDataset.Create(Self);
Dataset.LocateSmartRefresh := True;
Dataset.LookupSmartRefresh := True;
Dataset.Database := Db;

{ Dataset used to execute direct SQL on user demand }
SQLDirectDataset := TSqlitePassDataset.Create(Self);
SQLDirectDataset.Database := Db;
SQLDirectDataset.ReadOnly := False;
dsSQLDirect.DataSet := SQLDirectDataset;

{ MRU Files }
MRUFileList := TStringList.Create;
ToolboxDbAvailable := True;

try
LoadMRUFiles;
except
On Exception do
   begin
   ToolboxDbAvailable := False;
   MessageDlg('The database "SqlitePassToolBox.db3" was not found in program directory or cannot be opened.'
              +' Please Reinstall this file in the program directory.', mtWarning, [mbOk], -1);
   end;
end;

{ Reset Toolbars etc...}
TvChange(MainForm,  nil);
PageControlDataset.ActivePage := TsDatasetData;
{$IFNDEF FPC}
InitMenuImages;
{$ENDIF}
InitToolBarImages;
Application.OnIdle := ApplicationIdleHandler;
ActionsNeedUpdate := True;
end;

procedure TMainForm.CbDbReadOnlyChange(Sender: TObject);
begin
  Db.ReadOnly := CbDbReadOnly.Checked;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
{ No need to free Db or datasets since the owner will do it automatically }
CbIndexedFields.Free;
ImIndexDirection.Free;
ListofPanelFieldDefProperties.Free;
ListofPanelFieldDefFieldNames.Free;
MRUFileList.Free;
end;

{ Terminates the application }

procedure TMainForm.ActionApplicationQuitExecute(Sender: TObject);
begin
Application.Terminate;
end;

{ Opens / Closes a database }

procedure TMainForm.ActionDatabaseOpenExecute(Sender: TObject);
begin
OpenDatabaseFile;
end;

procedure TMainForm.OpenDatabaseFile(FileName: String = '');
begin
if (FileName = '') then
   if OpenFileDialog.Execute and (OpenFileDialog.FileName <> '')
      then FileName := OpenFileDialog.FileName
      else exit;

if FileName <> '' then
   begin
   Db.Close;
   Db.Database := FileName;
   Db.Open;
   if Db.Connected then
      begin
      AddNewMRUFile(Db.Database);
      UpdateMRUFiles;
      RefreshTreeview;
      Tv.Selected := DatabaseNode;
      ActionsNeedUpdate := True
      end;
   end;
end;

procedure TMainForm.ActionDatabaseCloseExecute(Sender: TObject);
begin
if db.Engine.Transaction.Level > 0 then
   begin
   MessageDlg('The database cannot be closed because a transaction is still running.'
              +' Please commit or rollback this transaction before leaving.', mtWarning, [mbOk], -1);
   exit;
   end;

if Db.DatabaseError.ErrorCount > 0 then
   if MessageDlg(IntToStr(Db.DatabaseError.ErrorCount) + ' error(s) are logged in the database errors log. '
        +' Do you want to watch the errors before leaving ?', mtInformation, [mbYes, mbNo], -1) = mrYes
           then ActionDatabaseShowErrorLogExecute(Self);

Db.Close;
Tv.Items.Clear;
TvChange(Self, nil);
ActionsNeedUpdate := True;
end;

procedure TMainForm.RefreshActions;
var
i: integer;
Enabled, IsTableSelected, IsQuerySelected,
IsViewSelected, IsSQLStmtSelected: Boolean;
begin
If Not ActionsNeedUpdate then Exit;

{ Database }
Enabled := Db.Connected;

for i := 0 to Pred(ActionListDatabase.ActionCount) do
    TAction(ActionListDatabase.Actions[i]).Enabled := Enabled;

ActionDatabaseOpen.Enabled := Not Enabled;

{ Transactions }
ActionDatabaseTransactionStart.Enabled := Enabled and (Db.Engine.Transaction.Level = 0);
ActionDatabaseTransactionCommit.Enabled := Enabled and (Db.Engine.Transaction.Level > 0);
ActionDatabaseTransactionRollback.Enabled := Enabled and (Db.Engine.Transaction.Level > 0);

ActionDatabaseDetach.Enabled := False;

{ Always TRUE }
ActionDatabaseCreateNew.Enabled := True;

{ Dataset }
Enabled := Dataset.Active and Not Dataset.IsEmpty;
ActionDatasetRefresh.Enabled := Enabled;
ActionDatasetShowSortDialog.Enabled := Enabled;
ActionDatasetFilterOnSelection.Enabled := Enabled;
ActionDatasetShowFilterDialog.Enabled := Enabled;
ActionDatasetFilterOnOff.Enabled := Enabled and (DialogFilterString <> '');
ActionDatasetShowLocateDialog.Enabled := Enabled;
ActionDatasetLocateFirst.Enabled := Enabled and (Dataset.LocateRecordCount > 0);
ActionDatasetLocatePrior.Enabled := Enabled and (Dataset.LocateRecordCount > 0);
ActionDatasetLocateNext.Enabled := Enabled and (Dataset.LocateRecordCount > 0);
ActionDatasetLocateLast.Enabled := Enabled and (Dataset.LocateRecordCount > 0);

{ Tables }
ActionTableCreateNew.Enabled := Db.Connected;
IsTableSelected := Assigned(Tv.Selected) and (Tv.Selected.Parent = TablesNode);
ActionTableModify.Enabled  := IsTableSelected;
ActionTableRename.Enabled  := IsTableSelected;
ActionTableReindex.Enabled := IsTableSelected;
ActionTableSaveAsView.Enabled := IsTableSelected;
ActionTableEmpty.Enabled   := IsTableSelected;
ActionTableDelete.Enabled  := IsTableSelected;

{ Queries }
ActionQueryCreateNew.Enabled := Db.Connected;
IsQuerySelected := Assigned(Tv.Selected) and (Tv.Selected.Parent = QueriesNode);
ActionQueryModify.Enabled  := IsQuerySelected;
ActionQueryRename.Enabled  := IsQuerySelected;
//ActionQuerySaveAsView.Enabled := IsQuerySelected;
ActionQueryDelete.Enabled  := IsQuerySelected;

{ Views }
ActionViewCreateNew.Enabled := Db.Connected;
IsViewSelected := Assigned(Tv.Selected) and (Tv.Selected.Parent = ViewsNode);
ActionViewModify.Enabled  := IsViewSelected;
ActionViewRename.Enabled  := IsViewSelected;
//ActionViewSaveAsView.Enabled := IsViewSelected;
ActionViewDelete.Enabled  := IsViewSelected;


{ SQL Statement }
ActionSQLStmtCreateNew.Enabled := Db.Connected;

IsSQLStmtSelected := False;
if Assigned(Tv.Selected) then
   if Assigned(Tv.Selected.Parent) then
      if (Assigned(Tv.Selected.Parent.Parent) and (Tv.Selected.Parent.Parent = SQLNode))
         then IsSQLStmtSelected := True;

ActionSQLStmtDelete.Enabled  := IsSQLStmtSelected;
ActionSQLStmtRename.Enabled  := IsSQLStmtSelected;

ActionsNeedUpdate := False;
end;

{ Displays Databases parts in a Treeview }

procedure TMainForm.TvChange(Sender: TObject; Node: TTreeNode);
var
i : Integer;

begin

{ Database is closed ? }
if Node = nil
   then begin
   for i := 0 to Pred(PageControl.PageCount)
    do PageControl.Pages[i].TabVisible := False;
   exit;
   end;

{ Default }
Tv.PopupMenu := PopupMenuDatabase;

{ Database }
if Node = DatabaseNode
   then begin
   ShowDatabaseInfos;
   PageControl.Pages[0].Tabvisible := True;
   PageControl.Pages[1].Tabvisible := False;
   PageControl.Pages[2].Tabvisible := False;
   end;

if Node.Parent = nil then exit;

{ Datasets }
if (Node.Parent = TablesNode) or (Node.Parent = SystemTablesNode)
   then Tv.PopupMenu := PopupMenuTables;

{ Queries }
if (Node.Parent = QueriesNode)
   then Tv.PopupMenu := PopupMenuQueries;

{ Views }
if (Node.Parent = ViewsNode)
   then Tv.PopupMenu := PopupMenuViews;

if ((Node.Parent = TablesNode) or (Node.Parent = SystemTablesNode)
     or (Node.Parent = QueriesNode) or (Node.Parent = ViewsNode)
     or (Node.Parent = SQLSelectNode))
     then begin
     ShowDatasetInfos(Node);
     PageControl.Pages[0].Tabvisible := False;
     PageControl.Pages[1].Tabvisible := True;
     { SQL Select }
     PageControl.Pages[2].Tabvisible := (Node.Parent = SQLSelectNode);
     { Indexes Tab }
     PageControlDataset.Pages[2].Tabvisible := (Node.Parent <> QueriesNode)
                                                and (Node.Parent <> ViewsNode);
     end;

{ SQL }
if (Node = SQLNode) or (Node.Parent = SQLNode) or (Node.Parent.Parent = SQLNode)
   then begin
   PageControl.Pages[0].Tabvisible := False;
   PageControl.Pages[1].Tabvisible := (Node.Parent = SQLSelectNode);
   PageControl.Pages[2].Tabvisible := True;
   Tv.PopupMenu := PopupMenuSQLStmts;
   if Node.Parent.Parent = SQLNode then
      begin
      MemoSQLStmt.Clear;
      LabelSQLStmtName.Caption := Node.Text;
      MemoSQLStmt.Lines.Assign(Db.SQLStmts.SQLStmtByName(Node.Text).SQL);
      SQLDirectDataset.Close;
      PanelSQLResult.Visible := False;
      end;
   end;

ActionsNeedUpdate := True;
end;


{ Displays infos on current database }

procedure TMainForm.ActionDatabaseRefreshExecute(Sender: TObject);
begin
   Db.RefreshDefinitions;
   ShowDatabaseInfos;
end;

procedure TMainForm.ActionDatabaseCompactSizeExecute(Sender: TObject);
begin
ShowMessage(IntToStr(Db.Compact) + ' octets have been freed from the database : '+ Db.Database);
ActionDatabaseRefreshExecute(Sender);
end;


{ Displays infos on Status Bar }

procedure TMainForm.RefreshStatusBar;
begin
With StatusBar do
     begin
     if Db.Connected
        then begin
             Panels[0].Text := ' Sqlite Engine : ' + Db.VersionInfo.SqliteLibrary;
             Panels[1].Text := ' Database : ' + Db.Database;
             Panels[2].Text := ' Database type : ' + DatabaseTypeAsString;
             if Dataset.Active
                then Panels[3].Text := ' Elapsed Time : ' + FloatToStr(Dataset.Database.Engine.ElapsedTime);
              end
        else begin // Db is not Connected
             Panels[0].Text := ' Sqlite Engine : Unknown...';
             Panels[1].Text := ' Database : Unknown...';
             Panels[2].Text := ' Database type : Unknown...';
             Panels[3].Text := ' Elapsed Time : Unknown...';
             end;
     Hint := Panels[0].Text + '  ' + Panels[1].Text + '  ' +  Panels[2].Text + '  ' +  Panels[3].Text;
     end;
end;


{ Loads / Shows / Saves images (Blobs) }

procedure TMainForm.BtLoadPictureFromFileClick(Sender: TObject);
begin
if OpenPictureDialog.Execute
   then begin
        Dataset.Edit;
        TBlobField(DbImage.Field).LoadFromFile(OpenPictureDialog.Filename);
        end;
end;

procedure TMainForm.BtClearPictureClick(Sender: TObject);
begin
 Dataset.Edit;
 DbImage.Field.Clear;
end;

procedure TMainForm.BtSavePictureToFileClick(Sender: TObject);
begin
If SavePictureDialog.Execute
   then TBlobField(DbImage.Field).SaveToFile(SavePictureDialog.Filename);
end;

procedure TMainForm.CbShowGraphicClick(Sender: TObject);
begin
if cbShowGraphic.Checked
 then ComboBoxGraphicFieldsChange(Sender);
end;

procedure TMainForm.ComboBoxGraphicFieldsChange(Sender: TObject);
var
F: TField;
begin
if ComboBoxGraphicFields.Text = '' then exit;
F := Dataset.FieldByName(ComboBoxGraphicFields.Text);
if (F <> nil) and CbShowGraphic.Checked
   then begin
        if F.DataType in [ftBlob, ftGraphic] then
           begin
           DbImage.DataField := ComboBoxGraphicFields.Text;
           {$IFDEF FPC }
           DbImage.DataSource := DataSource;
           {$ENDIF}
           end;
        end
//        else DbImage.DataField := '';
end;


{ Loads / Shows / Saves Memos (Blobs) }

procedure TMainForm.CbShowMemoClick(Sender: TObject);
begin
if cbShowMemo.Checked
   then ComboBoxMemoFieldsChange(Sender);
end;

procedure TMainForm.BtLoadMemoFromFileClick(Sender: TObject);
begin
if OpenFileDialog.Execute
   then begin
        Dataset.Edit;
        TMemoField(DbMemo.Field).LoadFromFile(OpenFileDialog.FileName);
        end;
end;

procedure TMainForm.BtClearMemoClick(Sender: TObject);
begin
 Dataset.Edit;
 TBlobField(DbMemo.Field).Clear;
 Dataset.Post;
end;

procedure TMainForm.BtSaveMemoToFileClick(Sender: TObject);
begin
If SaveFileDialog.Execute
   then TBlobField(DbMemo.Field).SaveToFile(SaveFileDialog.Filename);
end;


procedure TMainForm.DbSettingChanged(Sender: TObject);
begin
 SbDbApplyChanges.Enabled := True;
 SbDbCancelChanges.Enabled := True;
end;

procedure TMainForm.SbDbCancelChangesClick(Sender: TObject);
begin
if MessageDlg('Do you really want to undo all the changes ? ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
   SbDbApplyChanges.Enabled := False;
   SbDbCancelChanges.Enabled := False;
   ActionDatabaseRefreshExecute(Sender);
   end;
end;


procedure TMainForm.ListBoxIndexDefsClick(Sender: TObject);
begin
RefreshIndexInfos(Db.IndexDefs.FindIndex(ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex]));
end;

procedure TMainForm.ActionApplicationShowAboutExecute(Sender: TObject);
begin
ShowMessage('SQLiteToolBox. SQLitePass Components Demo Program. Version : '+ Db.VersionInfo.Component + '.'+ #13#10 +
            'This program is FREEWARE, under GNU Lesser General Public License. Enjoy !' + #13#10 +
            'Icon sets : Silk icon set 1.3 by Mark James (http://www.famfamfam.com/lab/icons/silk/)'+ #13#10 +
            'Contributor : Luc David (luckylazarus@free.fr)');

end;

procedure TMainForm.ActionShowSQLPageExecute(Sender: TObject);
begin
Tv.Selected := SQLNode;
end;

procedure TMainForm.ActionDatabaseTransactionStartExecute(Sender: TObject);
begin
Db.Engine.Transaction.Start;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatabaseTransactionCommitExecute(
  Sender: TObject);
begin
Db.Engine.Transaction.Commit;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatabaseTransactionRollbackExecute(
  Sender: TObject);
begin
Db.Engine.Transaction.Rollback;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatabaseAttachExecute(Sender: TObject);
begin
if OpenFileDialog.Execute then
   begin
   Db.AttachDatabase(OpenFileDialog.FileName,'');
   RefreshTreeview;
   end;
end;

procedure TMainForm.ActionDatabaseDetachExecute(Sender: TObject);
begin
Try
 Db.DetachDatabase(GridAttachedDatabases.Cells[0,GridAttachedDatabases.row]);
finally
 RefreshTreeview;
end;
end;

procedure TMainForm.DBGridDatasetDataTitleClick(Column: TColumn);
var
i, SortPos: Integer;
SortDirection: String;

begin
Try
Dataset.DisableControls;

For i := 0 to Pred(DBGridDatasetData.Columns.Count)
    do DBGridDatasetData.Columns[i].Title.Font.Color := clBlack;

SortDirection := ' ASC';
SortPos := Pos('<Asc> ', Column.Title.Caption);
if SortPos > 0
   then SortDirection := ' DESC'
   else begin
        SortPos := Pos('<Desc> ', Column.Title.Caption);
        if SortPos > 0 then SortDirection := ' ASC';
        end;
Column.Title.Caption := StringReplace(Column.Title.Caption, '<Asc> ', '', []);
Column.Title.Caption := StringReplace(Column.Title.Caption, '<Desc> ', '', []);
if SortDirection = ' ASC'
   then Column.Title.Caption := '<Asc> ' + Column.Title.Caption
   else Column.Title.Caption := '<Desc> ' + Column.Title.Caption;

For i := 0 to Pred(DBGridDatasetData.Columns.Count)
    do if DBGridDatasetData.Columns[i] <> Column then
          begin
          DBGridDatasetData.Columns[i].Title.Caption := StringReplace(DBGridDatasetData.Columns[i].Title.Caption, '<Asc> ', '', []);
          DBGridDatasetData.Columns[i].Title.Caption := StringReplace(DBGridDatasetData.Columns[i].Title.Caption, '<Desc> ', '', []);
          end;

Column.Title.Font.Color := clRed;
Dataset.SortedBy := '"' + Column.FieldName + '" ' + SortDirection;
Dataset.Sort;
finally
Dataset.EnableControls;
end;
end;

procedure TMainForm.ActionDatasetShowSortDialogExecute(Sender: TObject);
var
i: integer;
F: TSqlitePassSortedByDialog;
begin
F := TSqlitePassSortedByDialog.Create(Self, Dataset.SortedBy, Dataset.Fields);
F.ShowModal;
if F.ModalResult = mrOk then
   begin
   For i := 0 to Pred(DBGridDatasetData.Columns.Count)
       do DBGridDatasetData.Columns[i].Title.Font.Color := clBlack;
   Dataset.Sorted := True;
   Dataset.SortedBy := F.SQL;
   Dataset.Sort;
   end;
F.Free;
end;

procedure TMainForm.ShowDatabaseInfos;
var
i: integer;
f: TFileStream;
begin
if not Db.Connected then exit;
Tv.Selected := DatabaseNode;
{ Infos }
LabelDbType.Caption := DatabaseTypeAsString;
f := TFileStream.Create(Db.Database, fmOpenRead or fmShareDenyNone);;
LabelDbFileSize.Caption := IntToStr(F.Size) + ' octets';
f.free;
EditDbQueryTimeout.Text := IntToStr(Db.QueryTimeout);
EditDbUserTag.Text := IntToStr(Db.UserTag);
CbDbShowSystemObjects.Checked := Db.ShowSystemObjects;
CbDbReadOnly.Checked := Db.ReadOnly;
CbDbSmartOpen.Checked := Db.SmartOpen;

{ Versions }
LabelDbComponentVersion.Caption := Db.VersionInfo.Component;
LabelDbSqliteLibVersion.Caption := Db.VersionInfo.SqliteLibrary;
LabelDbVersion.Caption := IntToStr(Db.VersionInfo.Schema);
LabelDbKexiVersion.Caption := Db.VersionInfo.DbVersion;

{ Options }
EditDbCacheSize.Text := IntToStr(Db.Options.CacheSize);
CbDbVacuumType.ItemIndex := Db.Options.AutoVacuum;
CbDbCountChanges.Checked := Db.Options.CountChanges;
CbDbCaseSensitiveLike.Checked := Db.Options.CaseSensitiveLike;
CbDbEmptyResultCallback.Checked := Db.Options.EmptyResultCallback;
CbDbFullColumnName.Checked := Db.Options.FullColumnNames;
EditDbPageSize.Text := IntToStr(Db.Options.PageSize);
EditDbEncoding.Text := DatabaseEncodingAsString;
EditDbTemporaryStorage.Text := '';
{ Synchronous }

{ --- Display Attached Databases Infos ---  }
With GridAttachedDatabases do
  begin
  cells[0,0] := 'Alias name';
  cells[1,0] := 'Database';
  { Clear Grid }
  for i := 1 to 9 do  // should be 1 to 10 -> Lazarus TVirtualGrid.GetCells(Col, Row: Integer) bug ?
    begin
    Cells[0,i] := '';
    Cells[1,i] := '';
    end;
  { Refresh Grid }
  if (Db.Databases.count > 0) then
  begin
  for i := 0 to Pred(Db.Databases.count) do
    begin
    Cells[0,i+1] := Db.Databases[i].AliasName;
    Cells[1,i+1] := Db.Databases[i].Database;
    end;
  end;
  end;
end;


procedure TMainForm.ShowDatasetInfos(Node: TTreeNode);
var
i: Integer;
MyTableDef: TSqlitePassTableDef;
NewPanelFieldDefTitle: TPanelFieldDefTitle;
NewPanelFieldDef: TPanelFieldDefPropertiesValues;
PanelFieldDefTop, PanelFieldDefLeft, PanelFieldDefHOffset: Integer;
begin
With MainForm do
begin
  PageControl.ActivePage := TsDataset;
  {$IFDEF FPC }
  DbImage.DataSource := nil; // Otherwise DbImage.DataField := '' raise exception 'Field '' not found wit FPC
  {$ENDIF}
  DbImage.DataField := '';
  ComboBoxGraphicFields.Clear;
  ComboBoxGraphicFields.Text := '';
  {$IFDEF FPC }
  DbMemo.DataSource := nil; // Otherwise DbImage.DataField := '' raise exception 'Field '' not found wit FPC
  {$ENDIF}
  DbMemo.DataField := '';
  ComboBoxMemoFields.Clear;
  ComboBoxMemoFields.Text := '';

  { Reset Filter Action Hint}
  DialogFilterString := '';
  ActionDatasetFilterOnSelection.Hint := 'Select to filter on current selected field value';
  LabelLocateRecordCount.Caption := 'No record located';
  LabelRecordCount.Caption := 'Records count : 0';

  { Show Data }
  With Dataset do
  begin
  Close;
  ReadOnly := False;
  Database := Db;
  Try
  DatasetName := Node.Text;
  Open;
  Except
  Close;
  Abort;
  end;

  PageControl.ActivePage.Caption := 'Dataset : ' + DatasetName;
  MemoSqlCreateStmt.Clear;
  MyTableDef := Db.TableDefs.FindTable(Node.Text);
  If Assigned(MyTableDef)
     then MemoSqlCreateStmt.Lines.Text := MyTableDef.Sql;
  MemoSqlSelectStmt.Clear;
  MemoSqlSelectStmt.Lines.Text := SQL.Text;
  if ReadOnly or not CanModify
     then begin
     DbNavDataset.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbRefresh];
     ImageDatasetReadOnly.Visible := True;
     LabelDatasetReadOnly.Visible := True;
     end
     else begin
     DbNavDataset.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbInsert, nbEdit, nbDelete, nbPost, nbCancel, nbRefresh];
     ImageDatasetReadOnly.Visible := False;
     LabelDatasetReadOnly.Visible := False;
     end;
  end;
  DataSource.DataSet := Dataset;

  { --- Display FieldDefs Infos ---  }
  ScrollBoxFieldDefsFieldNames.visible := False;
  ScrollBoxFieldDefsPropertiesValues.visible := False;

  For i := 0 to Pred(ListofPanelFieldDefProperties.Count)
    do begin
    TPanelFieldDefTitle(ListofPanelFieldDefFieldNames[i]).Free;
    TPanelFieldDefPropertiesValues(ListofPanelFieldDefProperties[i]).Free;
    end;

  ListofPanelFieldDefProperties.Clear;
  ListofPanelFieldDefFieldNames.Clear;

  PanelFieldDefTop := 2;
  PanelFieldDefLeft := 2;

   For i := 0 to Pred(Dataset.SQLSelectStmt.FieldDefs.Count) do
    begin
        NewPanelFieldDefTitle:= TPanelFieldDefTitle.CreateAtPos(ScrollboxFieldDefsFieldNames, PanelFieldDefTop, PanelFieldDefLeft + 2);
        NewPanelFieldDefTitle.Caption := Dataset.SQLSelectStmt.FieldDefs[i].FieldName;
        ListofPanelFieldDefFieldNames.Add(NewPanelFieldDefTitle);
        NewPanelFieldDef := TPanelFieldDefPropertiesValues.CreateAtPos(ScrollBoxFieldDefsPropertiesValues, PanelFieldDefTop, PanelFieldDefLeft);
        With NewPanelFieldDef do
        begin
        FDataType.Caption := FieldTypeToString(Dataset.SQLSelectStmt.FieldDefs[i].DataType);
        FDataType.Hint := FDataType.Caption;
        FAutoInc.Value := Dataset.SQLSelectStmt.FieldDefs[i].AutoInc;
        FDefaultValue.Caption := Dataset.SQLSelectStmt.FieldDefs[i].DefaultValue;
        FDefaultValue.Hint := FDefaultValue.Caption;
        FDisplayName.Caption := Dataset.SQLSelectStmt.FieldDefs[i].DisplayName;
        FDisplayName.Hint := FDisplayName.Caption;
        FFieldNo.Caption := IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].FieldNo);
//        FFieldFullName.Caption := Dataset.SQLSelectStmt.FieldDefs[i].FieldFullName;
        FForeignKey.Value := Dataset.SQLSelectStmt.FieldDefs[i].ForeignKey;
        FHint.Caption := Dataset.SQLSelectStmt.FieldDefs[i].Hint;
        FHint.Hint := FHint.Caption;
        FIndexed.Value := Dataset.SQLSelectStmt.FieldDefs[i].Indexed;
        FInternalPrimaryKey.Value := Dataset.SQLSelectStmt.FieldDefs[i].InternalPrimaryKey;
        FNativeDataType.Caption := Dataset.SQLSelectStmt.FieldDefs[i].NativeDataType;
        FNativeDataType.Hint := FNativeDataType.Caption;
        FNativeDataTypeCode.Caption := IntToSTr(Dataset.SQLSelectStmt.FieldDefs[i].NativeDataTypeCode);
        FNotEmpty.Value := Dataset.SQLSelectStmt.FieldDefs[i].NotEmpty;
        FNoConstraints.Value := Dataset.SQLSelectStmt.FieldDefs[i].NoConstraints;
        FNotNull.Value := Dataset.SQLSelectStmt.FieldDefs[i].NotNull;
        FPrecision.Caption := IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].Precision);
        FPrimaryKey.Value := Dataset.SQLSelectStmt.FieldDefs[i].PrimaryKey;
        FSize.Caption := IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].Size);
        FUnique.Value := Dataset.SQLSelectStmt.FieldDefs[i].Unique;
        end;
        Case Dataset.SQLSelectStmt.FieldDefs[i].DataType of
          ftGraphic, ftBlob : ComboBoxGraphicFields.Items.Add(Dataset.SQLSelectStmt.FieldDefs[i].FieldName);
          ftMemo            : ComboBoxMemoFields.Items.Add(Dataset.SQLSelectStmt.FieldDefs[i].FieldName);
          end;

        PanelFieldDefHOffset := NewPanelFieldDef.Width + 2;
        Inc(PanelFieldDefLeft, PanelFieldDefHOffset);
        ListofPanelFieldDefProperties.Add(NewPanelFieldDef);
     end;


  ScrollbarHorizontal.Max := PanelFieldDefHOffset + 2000;
  ScrollBoxFieldDefsFieldNames.visible := True;
  ScrollBoxFieldDefsPropertiesValues.visible := True;


  { Display IndexDefs Infos }
  RefreshIndexList;

  { Display available Blobs fields }
  if ComboBoxGraphicFields.Items.Count > 0 then
     begin
     ComboBoxGraphicFields.Text := ComboBoxGraphicFields.Items[0];
     ComboBoxGraphicFieldsChange(Self);
     end;

  if ComboBoxMemoFields.Items.Count > 0 then
     begin
     ComboBoxMemoFields.Text := ComboBoxMemoFields.Items[0];
     ComboBoxMemoFieldsChange(Self);
     end;

  LabelRecordCount.Caption := 'Records count : ' + IntToStr(Dataset.RecordCount);
  RefreshStatusBar;
end;
end;

procedure TMainForm.RefreshTreeview(NodeCaption: String = '');

 function AddNode(ParentNode: TTreeNode; Caption: String; ImageIndex, SelectedImageIndex: Integer): TTreeNode;
   begin
   if Assigned(ParentNode)
      then Result := Tv.Items.AddChild(ParentNode,Caption)
      else Result := Tv.Items.Add(nil,'Database');
   Result.ImageIndex := ImageIndex;
   Result.SelectedIndex := SelectedImageIndex;
   end;

const
EmptyImageIndex = -1;
SelectedImageIndex = 1;
DatabaseImageIndex = 0;
TableImageIndex = 2;
QueryImageIndex = 3;
WiewImageIndex = 4;
TriggerImageIndex = 5;
SQLImageIndex = 6;
SQLItemImageIndex = 7;
SystemTableImageIndex = 8;
ItemImageIndex = 9;

var
i: Integer;
TvItem: TTreeNode;

begin
Try
if (NodeCaption = '') and Assigned(Tv.Selected)
   then NodeCaption := Tv.Selected.Text;

Tv.Items.BeginUpdate;

Tv.Items.Clear;
DatabaseNode := nil;
TablesNode   := nil;
QueriesNode  := nil;
ViewsNode    := nil;
TriggersNode := nil;
SQLNode := nil;
SQLCreateNode := nil;
SQLCreateTableNode := nil;
SQLSelectNode := nil;
SQLInsertNode := nil;
SQLUpdateNode := nil;
SQLDeleteNode := nil;
SQLOthersNode := nil;

DatabaseNode := AddNode(nil,'Database',DatabaseImageIndex,DatabaseImageIndex);
TablesNode   := AddNode(DatabaseNode,'Tables',TableImageIndex,TableImageIndex);
QueriesNode  := AddNode(DatabaseNode,'Queries',QueryImageIndex,QueryImageIndex);
ViewsNode    := AddNode(DatabaseNode,'Views',WiewImageIndex,WiewImageIndex);
TriggersNode := AddNode(DatabaseNode,'Triggers',TriggerImageIndex,TriggerImageIndex);
SQLNode := AddNode(DatabaseNode,'SQL',SQLImageIndex,SQLImageIndex);
SystemTablesNode := AddNode(DatabaseNode,'System Tables',SystemTableImageIndex,SystemTableImageIndex);

for i:= 0 to Pred(Db.TableDefs.Count)
    do if Not Db.IsSystemTable(Db.TableDefs[i].TableName)
       then AddNode(TablesNode,Db.TableDefs[i].TableFullName,ItemImageIndex,SelectedImageIndex)
       else AddNode(SystemTablesNode, Db.TableDefs[i].TableFullName,ItemImageIndex,SelectedImageIndex);

for i:= 0 to Pred(Db.QueryDefs.Count)
    do AddNode(QueriesNode,Db.QueryDefs[i].QueryFullName,ItemImageIndex, SelectedImageIndex);

for i:= 0 to Pred(Db.Views.Count)
    do AddNode(ViewsNode,Db.Views[i].ViewName,ItemImageIndex, SelectedImageIndex);

for i:= 0 to Pred(Db.Triggers.Count)
    do AddNode(TriggersNode, Db.Triggers[i].TriggerName,ItemImageIndex, SelectedImageIndex);

for i:= 0 to Pred(Db.SQLStmts.Count)
    do begin
       case Db.SQLStmts[i].SQLType of
            stSelect: begin
                      if Not Assigned(SQLSelectNode)
                         then SQLSelectNode := AddNode(SQLNode,'(Select)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLSelectNode,Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            stCreate: begin
                      if Not Assigned(SQLCreateNode)
                         then SQLCreateNode:= AddNode(SQLNode,'(Create)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLCreateNode,Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            stCreateTable: begin
                      if Not Assigned(SQLCreateTableNode)
                         then SQLCreateTableNode := AddNode(SQLNode,'(Create Table)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLCreateTableNode,Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            stInsert: begin
                      if Not Assigned(SQLInsertNode)
                         then SQLInsertNode := AddNode(SQLNode,'(Insert)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLInsertNode,Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            stUpdate: begin
                      if Not Assigned(SQLUpdateNode)
                         then SQLUpdateNode := AddNode(SQLNode,'(Update)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLUpdateNode,Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            stDelete: begin
                      if Not Assigned(SQLDeleteNode)
                         then SQLDeleteNode := AddNode(SQLNode,'(Delete)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLDeleteNode,Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            else      begin
                      if Not Assigned(SQLOthersNode)
                         then SQLOthersNode := AddNode(SQLNode, '(Others)',SQLItemImageIndex,SelectedImageIndex);
                      AddNode(SQLOthersNode, Db.SQLStmts[i].StmtName,ItemImageIndex,SelectedImageIndex);
                      end;
            end; { Case }
       end;
finally
Tv.FullExpand;
TreeViewSelectByName(NodeCaption);
Tv.Items.EndUpdate;
ActionsNeedUpdate := True;
end;
end;

procedure TMainForm.ComboBoxMemoFieldsChange(Sender: TObject);
var
F: TField;
begin
if ComboBoxMemoFields.Text = '' then exit;
F := Dataset.FieldByName(ComboBoxMemoFields.Text);
if (F <> nil) and CbShowMemo.Checked
   then begin
        if F.DataType = ftMemo then
           begin
           DbMemo.DataField := ComboBoxMemoFields.Text;
           {$IFDEF FPC }
           DbMemo.DataSource := DataSource;
           {$ENDIF}
           end;
        end
//        else DbMemo.DataField := '';
end;


{ --- Dataset Index --- }

{ Indexes Management }

procedure TMainForm.ActionIndexRenameExecute(Sender: TObject);
begin
FormRenameItem := TFormRenameItem.Create(Self);
FormRenameItem.LabelRenameItem.Caption := 'Rename index '
                               + ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex] + ' as :';
if FormRenameItem.ShowModal = mrOk
   then begin
   Dataset.Database.IndexDefs.RenameIndex(ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex], FormRenameItem.EditNewName.Text);
   RefreshIndexList;
   end;
FormRenameItem.Free;
end;

procedure TMainForm.ActionIndexCreateNewExecute(Sender: TObject);
begin
FormCreateNewIndex := TFormCreateNewIndex.Create(Self, Dataset);
if FormCreateNewIndex.ShowModal = mrOk
   then RefreshIndexList;
FormCreateNewIndex.Free;
end;

procedure TMainForm.ActionIndexDeleteExecute(Sender: TObject);
begin
Dataset.Database.IndexDefs.DeleteIndex(ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex]);
RefreshIndexList;
end;

procedure TMainForm.ActionIndexRefreshExecute(Sender: TObject);
begin
RefreshIndexList;
end;

procedure TMainForm.SbCancelIndexChangesClick(Sender: TObject);
var
SelectedIndex: Integer;
begin
SelectedIndex:= ListBoxIndexDefs.ItemIndex;
ActionIndexRefreshExecute(Sender);
ListBoxIndexDefs.ItemIndex := SelectedIndex;
ListBoxIndexDefsClick(Self);
RefreshIndexSpeedButtons(False);
end;

procedure TMainForm.RefreshIndexSpeedButtons(Enable: Boolean);
begin
SbApplyIndexChanges.Enabled := Enable;
SbCancelIndexChanges.Enabled := Enable;
end;

procedure TMainForm.CheckBoxUniqueIndexClick(Sender: TObject);
begin
RefreshIndexSpeedButtons(True);
end;

procedure TMainForm.OnCbIndexedFieldClick(Sender: TObject);
var
i : Integer;
begin
  i := CbIndexedFields.IndexOf(Sender);
  if i =-1 then Exit;
  if TCheckBox(CbIndexedFields[i]).Checked
     then begin
          with TImage(ImIndexDirection[i]) do
          begin
          Picture.Assign(ImageIndexDirectionDesc.Picture);
          Tag := 1;
          Visible := True;
          end;
          end
     else TImage(ImIndexDirection[i]).Visible := False;
RefreshIndexSpeedButtons(True);
end;

procedure TMainForm.OnImIndexDirectionClick(Sender: TObject);
begin
With TImage(Sender) do
 begin
 if Tag = 1
    then Tag := 2
    else Tag := 1;

 if Tag = 1
    then Picture.Assign(ImageIndexDirectionAsc.Picture)
    else Picture.Assign(ImageIndexDirectionDesc.Picture);
 end;
RefreshIndexSpeedButtons(True);
end;

procedure TMainForm.RefreshIndexList;
var
i, VOffset: Integer;
aCheckBox: TCheckBox;
aImage: TImage;

begin
ListBoxIndexDefs.Clear;

{ Free Existing checkboxes and Images }
for i:= 0 to Pred(CbIndexedFields.Count)
    do begin
       TCheckBox(CbIndexedFields[i]).Free;
       TImage(ImIndexDirection[i]).Free;
       end;
CbIndexedFields.Clear;
ImIndexDirection.Clear;

{ no index available ? }
if Dataset.IndexDefs.count = 0 then exit;

{ We fill the listbox with indexes names }
For i := 0 to Pred(Dataset.IndexDefs.count) do
ListBoxIndexDefs.items.Add(Dataset.IndexDefs[i].IndexName);

{ Create necessary checkboxes and Images to display info }
VOffset := 0;
for i := 0 to Pred(Dataset.FieldCount) do
    Begin
     if (Dataset.Fields[i].FieldKind=fkData) and (Dataset.Fields[i].Visible)
        then begin
        aCheckBox := TCheckBox.Create(ScrollBoxIndexedFields);
        With aCheckBox do
             begin
             Parent := ScrollBoxIndexedFields;
             Caption:=Dataset.Fields[i].FieldName;
             Top  := (VOffset*20)+5;
             Left := 30;
             Width := 200;
             Height := 16;
             OnClick:=OnCbIndexedFieldClick;
             end;

        aImage := TImage.Create(ScrollBoxIndexedFields);
        With aImage do
             begin
             Parent := ScrollBoxIndexedFields;
             Top  := (VOffset*20)+4;
             Left := 6;
             Width := 16;
             Height := 16;
             Transparent := True;
             OnClick:=OnImIndexDirectionClick;
             end;
        Inc(VOffset);
        CbIndexedFields.Add(aCheckBox);
        ImIndexDirection.Add(aImage);
       end;
    end;

{ Select the first index in the listbox }
ListBoxIndexDefs.ItemIndex := 0;

{ Display corresponding info }
ListBoxIndexDefsClick(Self);

end;

{ --- Display current index infos --- }
procedure TMainForm.RefreshIndexInfos(CurrentIndex: TSqlitePassIndex);
var
i: Integer;
MyIndexCol: TSqlitePassIndexColumn;
Image: TImage;
begin
If CurrentIndex = nil then exit;
{ Show SQL Create statement for the selected index }
MemoSQLIndexCreateStmt.Clear;
MemoSqlIndexCreateStmt.Lines.Text := CurrentIndex.Sql;
{ Show fields used by the selected index and sort order }
For i := 0 to Pred(Dataset.FieldCount) do
    begin
    if (Dataset.Fields[i].FieldKind=fkData) and (Dataset.Fields[i].Visible)
    then begin
         MyIndexCol := CurrentIndex.Columns.FindColumn(Dataset.Fields[i].FieldName);
         TCheckBox(CbIndexedFields[i]).Checked := (MyIndexCol <> nil);
         Image := TImage(ImIndexDirection[i]);
         if MyIndexCol <> nil
            then begin
                 Case MyIndexCol.Direction of
                 cidAscending  : begin
                                 Tag := 1;
                                 Image.Picture.Assign(ImageIndexDirectionAsc.Picture);
                                 end;
                 cidDescending : begin
                                 Tag := 2;
                                 Image.Picture.Assign(ImageIndexDirectionDesc.Picture);
                                 end;
                 cidUnknown    : begin
                                 Tag := 3;
                                 Image.Picture.Assign(ImageIndexDirectionUnknown.Picture);
                                 end;
                 end; { Case }
                 Image.Visible := True;
                 end
                 else Image.Visible := False; { if MyIndexCol = nil }
        end; { Dataset.Fields[i]... }
    end; { For... }
CheckBoxUniqueIndex.Checked := CurrentIndex.Unique;
RefreshIndexSpeedButtons(False);
end;


{ TPanelFieldDefPropertyValue }

constructor TPanelFieldDefPropertyValue.Create(AOwner: TPanel);
begin
Inherited Create(AOwner);
Parent := AOWner;
Height := 22;
Width := 102;
Color := clBtnface;
BevelInner := bvSpace;
BevelOuter := bvLowered;
Inc(TPanelFieldDefPropertiesValues(Parent).FTop, TPanelFieldDefPropertiesValues(Parent).FVOffset);
end;

constructor TPanelFieldDefPropertyValue.CreateAtPos(AOwner: TPanel;
  Top, Left: Integer);
begin
Create(AOwner);
Self.Top := Top;
Self.Left := Left;
end;

{ TPanelFieldDefPropertiesValues }

constructor TPanelFieldDefPropertiesValues.Create(AOwner: TComponent);
begin
Inherited Create(AOwner);
Parent := TScrollBox(AOwner);
end;

constructor TPanelFieldDefPropertiesValues.CreateAtPos(AOwner: TComponent; Top, Left: Integer);
begin
Create(AOwner);
Self.Top := Top;
Self.Left := Left;
Width := 110;
Height := 600;
Color := clBtnface;
ShowHint := True;
BevelInner := bvSpace;
BevelOuter := bvSpace;
FVOffset := 22;
FTop := 1;
FLeft := 4;
FDataType := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FAutoInc := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FDefaultValue := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FDisplayName := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FFieldNo := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FFieldFullName := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FForeignKey := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FHint := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FIndexed := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FInternalPrimaryKey := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNativeDataType := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNativeDataTypeCode := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNotEmpty := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNoConstraints := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNotNull := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FPrecision := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FPrimaryKey := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FSize := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FUnique := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
end;

destructor TPanelFieldDefPropertiesValues.Destroy;
begin
FDataType.Free;
FAutoInc.Free;
FDefaultValue.Free;
FDisplayName.Free;
FFieldNo.Free;
FFieldFullName.Free;
FForeignKey.Free;
FHint.Free;
FIndexed.Free;
FInternalPrimaryKey.Free;
FNativeDataType.Free;
FNativeDataTypeCode.Free;
FNotEmpty.Free;
FNoConstraints.Free;
FNotNull.Free;
FPrecision.Free;
FPrimaryKey.Free;
FSize.Free;
FUnique.Free;
Inherited Destroy;
end;

{ TPanelFieldDefBooleanPropertyValue }

constructor TPanelFieldDefBooleanPropertyValue.CreateAtPos(
  AOwner: TPanelFieldDefPropertiesValues; Top, Left: Integer);
begin
Inherited CreateAtPos(TPanel(AOwner), Top, Left);
FImage := TImage.Create(Self);
With FImage do
  begin
  Parent := Self;
  Width := 16;
  Height := 16;
  Transparent := True;
  Left := (Self.Width - Width) div 2;
  Top := (Self.Height - Height) div 2;
  end;
end;

destructor TPanelFieldDefBooleanPropertyValue.Destroy;
begin
FImage.Free;
Inherited Destroy;
end;

procedure TPanelFieldDefBooleanPropertyValue.SetFValue(
  const Value: Boolean);
begin
  FValue := Value;
  If FValue = True
     then FImage.Picture := MainForm.ImageCheck.Picture
     else FImage.Picture := nil;
end;

{ TPanelFieldDefTitle }

constructor TPanelFieldDefTitle.Create(AOwner: TComponent);
begin
Inherited Create(AOwner);
Parent := TScrollBox(AOwner);
Height := 22;
Width := 106;
Color := clBlack;
Font.Color := clWhite;
BevelInner := bvLowered;
BevelOuter := bvLowered;
end;

constructor TPanelFieldDefTitle.CreateAtPos(AOwner: TComponent; Top,
  Left: Integer);
begin
Create(AOwner);
Self.Top := Top;
Self.Left := Left;
end;

procedure TMainForm.ScrollBarVerticalScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
{$IFNDEF FPC}
ScrollboxFieldDefsPropertiesNames.ScrollBy(0,ScrollbarVertical.Position-ScrollPos);
ScrollboxFieldDefsPropertiesValues.ScrollBy(0,ScrollbarVertical.Position-ScrollPos);
{$ENDIF}
end;

procedure TMainForm.ScrollBoxFieldDefsPropertiesValuesResize(
  Sender: TObject);
begin
(*ScrollbarVertical.Min := 0;
ScrollbarVertical.Max := ScrollBoxFieldDefsPropertiesValues.Height;
ScrollbarHorizontal.Min := 0;
ScrollbarHorizontal.Max := ScrollBoxFieldDefsPropertiesValues.Width;*)
end;

procedure TMainForm.ScrollBarHorizontalScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
{$IFNDEF FPC}
ScrollboxFieldDefsFieldNames.ScrollBy(ScrollbarHorizontal.Position-ScrollPos,0);
ScrollboxFieldDefsPropertiesValues.ScrollBy(ScrollbarHorizontal.Position-ScrollPos,0);
{$ENDIF}
end;

(*procedure TMainForm.SbAppendRecordsClick(Sender: TObject);
var
i, j, TickCount, RecordCount: Integer;
begin
// Inserting Records - Speed Test.
Dataset.DisableControls;
//TickCount := Integer(GetTickCount);
RecordCount := StrToInt(EditRecordCount.Text);
if CheckBoxUseTransaction.Checked
   then Dataset.Database.Engine.Transaction.Start;

for i := 0 to RecordCount do
begin
Dataset.Append;
for j := 0 to Pred(Dataset.Fields.count) do
Case Dataset.Fields[j].DataType of
     ftString : Dataset.Fields[j].Value := 'Enre num : ' + IntToStr(i) + '-T' + IntToStr(TickCount);
     ftInteger: Dataset.Fields[j].Value := TickCount + j;
     ftFloat  : Dataset.Fields[j].Value := TickCount + j + 0.57;
     end;
Dataset.Post;
end;
if CheckBoxUseTransaction.Checked
   then Dataset.Database.Engine.Transaction.Commit;
Dataset.EnableControls;
RefreshStatusBar;
end;*)

function TMainForm.DatabaseTypeAsString: String;
begin
Case Db.DatabaseType of
     dbtSqlitePass  : Result := 'SQLitePass';
     dbtKexi        : Result := 'Kexi';
     dbtSqliteAdmin : Result := 'SQLite Administrator';
     dbtSqlite4Fpc  : Result := 'SQLite4FPC';
     dbtSqliteExpert: Result := 'SQLite Expert';
     else             Result := 'Unknown...';
     end;
end;

function TMainForm.DatabaseAutoVaccumAsString: String;
begin
Case Db.Options.AutoVacuum of
     0 : Result := 'Manual';
     1 : Result := 'Auto-Full';
     2 : Result := 'Auto-Incremental';
     end;
end;

function TMainForm.DatabaseEncodingAsString: String;
begin
Case Db.Options.Encoding of
     UTF_8   : Result := 'UTF-8';
     UTF_16  : Result := 'UTF-16';
     UTF_16le: Result := 'UTF-16le';
     UTF_16be: Result := 'UTF-16be';
     end;
end;

{ MRU Files }

procedure TMainForm.LoadMRUFiles;
begin
Try
DbSettings.Open;
DatasetSettings.DatasetName := 'MRUFiles';
DatasetSettings.Open;
MRUFileList.Assign(DatasetSettings.FieldByName('Files'));
finally
DbSettings.Close;
UpdateMRUFiles;
end;
end;

procedure TMainForm.SaveMRUFiles;
begin
if ToolboxDbAvailable and (MRUFileList.Count > 0) then
   begin
   DbSettings.Open;
   With DatasetSettings do
        begin
        DatasetName := 'MRUFiles';
        Open;
        First;
        Edit;
        DatasetSettings.FieldByName('Files').Assign(MRUFileList);
        Post;
        Close;
        end;
   DbSettings.Close;
   end;
end;

procedure TMainForm.AddNewMRUFile(FileName: String);
var
IndexOf: Integer;
begin
IndexOf := MRUFileList.IndexOf(FileName);
  if IndexOf = -1
     then MRUFileList.Insert(0, FileName)
     else MRUFileList.Exchange(0, IndexOf);

  if MRUFileList.Count > MaxMRUFilesCount
     then MRUFileList.Delete(Pred(MRUFileList.Count));
end;


procedure TMainForm.UpdateMRUFiles;
var
  i: Integer;
  NewItem: TMenuItem;
begin
  { Clear Menu Items }
  While MainMenu.Items[0].Count > MenuDatabaseItemsCount
        do MainMenu.Items[0].Delete(Pred(MainMenu.Items[0].Count));

  { Clear Combobox }
  CbMRUFiles.Clear;

  if MRUFileList.Count > 0 then
     begin
     { Menu Items }
     NewItem := TMenuItem.Create(MainMenu);
     NewItem.Caption := '-';
     MainMenu.Items[0].Add(NewItem);

     for i := 0 to Pred(MRUFileList.Count) do
         begin
         NewItem := TMenuItem.Create(MainMenu);
         NewItem.Caption := MRUFileList.Strings[i];
         //NewItem.ShortCut := TextToShortCut('&' + IntToStr(i+1));
         NewItem.OnClick := MRUFileOpen;
         if FileExists(MRUFileList.Strings[i])
            then MainMenu.Items[0].Add(NewItem);
         end;

     { Combobox }
     CbMRUFiles.Items.AddStrings(MRUFileList);
     end;
end;

procedure TMainForm.MRUFileOpen(Sender: TObject);
var
FileName: String;
begin
FileName := (TMenuItem(Sender).Caption);
{ Caption returns leading blanck space so we remove it (D4) }
OpenDatabaseFile(Trim(FileName));
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{ Db and Dataset to store program settings }
Db.Close;
SaveMRUFiles;
end;

procedure TMainForm.ActionDatasetShowLocateDialogExecute(Sender: TObject);
begin
LabelLocateRecordCount.Caption := 'No record located';
SqlitePassLocateDlg := TSqlitePassLocateDlg.Create(Self, Dataset);
SqlitePassLocateDlg.ShowModal;
SqlitePassLocateDlg.Free;
If Dataset.LocateRecordCount > 0
   then LabelLocateRecordCount.Caption := IntToStr(Dataset.LocateRecordCount) + ' record(s) located';
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatasetLocateFirstExecute(Sender: TObject);
begin
Dataset.LocateFirst;
end;

procedure TMainForm.ActionDatasetLocatePriorExecute(Sender: TObject);
begin
if Dataset.LocateMoveState = grBOF
   then Dataset.LocateLast
   else Dataset.LocatePrior
end;

procedure TMainForm.ActionDatasetLocateNextExecute(Sender: TObject);
begin
if Dataset.LocateMoveState = grEOF
   then Dataset.LocateFirst
   else Dataset.LocateNext;
end;

procedure TMainForm.ActionDatasetLocateLastExecute(Sender: TObject);
begin
Dataset.LocateLast;
end;

procedure TMainForm.ActionDatasetShowFilterDialogExecute(Sender: TObject);
begin
SqlitePassFilterDialog := TSqlitePassFilterDialog.Create(Self, Dataset);
if SqlitePassFilterDialog.ShowModal = mrOk then
   begin
   DialogFilterString := SqlitePassFilterDialog.MemoSQLFilterStmt.Text;
   SbDatasetFilterOnOff.Down := True;
   SbDatasetFilterOnOff.Click;
   end;

SqlitePassFilterDialog.Free;
end;


{ Filtering }

procedure TMainForm.ActionDatasetFilterOnSelectionExecute(Sender: TObject);
var
CanFilter: Boolean;
f: TField;
S, FilterString: String;
begin
f := DbGridDatasetData.SelectedField;

{$IFDEF FPC} // LCL bug with SbDatasetFilterOnSelection.Down ?
CanFilter := Assigned(f) and Not (Dataset.filtered or Dataset.IsEmpty);
{$ELSE}
CanFilter := SbDatasetFilterOnSelection.Down and Assigned(f)
             and Not (Dataset.filtered or Dataset.IsEmpty);
{$ENDIF}

If CanFilter
   then begin
        Case f.DataType of
                //TODO - Add Date conversion to enable correct filter on date, time, timestamp
                // the date 01/03/2007 should be translated to '2007-03-01' or '2007/03/01'
                ftDateTime, ftDate, ftTime,
                ftString, ftMemo           : S := '"';
               else
                S := '';
               End;
        FilterString := '[' + f.FieldName + '] = ' + S + f.AsString + S;
        Dataset.Filter := FilterString;
        ActionDatasetFilterOnSelection.Hint := 'Current filter is : ' + FilterString;
        end
   else ActionDatasetFilterOnSelection.Hint := 'Select to filter on current selected field value';

Dataset.Filtered := CanFilter;
SbDatasetFilterOnSelection.Down := CanFilter;
LabelRecordCount.Caption := 'Records count : ' + IntToStr(Dataset.RecordCount);
end;

procedure TMainForm.ActionDatasetFilterOnSelectionUpdate(Sender: TObject);
begin
Enabled := (DbGridDatasetData.SelectedField <> nil);
end;

procedure TMainForm.ActionDatasetFilterOnOffExecute(Sender: TObject);
begin
if SbDatasetFilterOnOff.Down
   then begin
        Dataset.Filter := DialogFilterString;
        ActionDatasetFilterOnOff.Hint := 'Current filter is : ' + DialogFilterString;
        end
   else begin
        if DialogFilterString = ''
           then ActionDatasetFilterOnOff.Hint := 'No filter defined'
           else ActionDatasetFilterOnOff.Hint := 'Select to filter on current selected filter : ' + DialogFilterString;
        end;
Dataset.Filtered := SbDatasetFilterOnOff.Down;
LabelRecordCount.Caption := 'Records count : ' + IntToStr(Dataset.RecordCount);
end;

procedure TMainForm.CbMRUFilesClick(Sender: TObject);
begin
OpenDatabaseFile(CbMRUFiles.Text);
CbMRUFiles.ItemIndex := 0;
end;

procedure TMainForm.ActionDatabaseShowErrorLogExecute(Sender: TObject);
begin
SqlitePassErrorLogDlg := TSqlitePassErrorLogDlg.Create(Self, Db);
SqlitePassErrorLogDlg.ShowModal;
SqlitePassErrorLogDlg.Free;
end;

procedure TMainForm.ActionDatasetRefreshExecute(Sender: TObject);
begin
 Dataset.Refresh;
end;

procedure TMainForm.ActionDatabaseShowFieldTypesTranslationRulesExecute(Sender: TObject);
begin
SqlitePassDatatypesDlg := TSqlitePassDatatypesDlg.Create(Db);
SqlitePassDatatypesDlg.ShowModal;
SqlitePassDatatypesDlg.Free;
TvChange(Self, Tv.Selected);
end;

procedure TMainForm.ActionDatabaseShowCustomFieldDefsExecute(
  Sender: TObject);
begin
SqlitePassCustomFieldDefsDlg := TSqlitePassCustomFieldDefsDlg.Create(Db);
SqlitePassCustomFieldDefsDlg.ShowModal;
SqlitePassCustomFieldDefsDlg.Free;
TvChange(Self, Tv.Selected);
end;

procedure TMainForm.ActionDatabaseCreateNewExecute(Sender: TObject);
begin
SqlitePassCreateNewDatabaseDlg := TSqlitePassCreateNewDatabaseDlg.Create(Self);
SqlitePassCreateNewDatabaseDlg.ShowModal;
SqlitePassCreateNewDatabaseDlg.Free;
end;

procedure TMainForm.ActionTableCreateNewExecute(Sender: TObject);
begin
SqlitePassCreateTableDlg := TSqlitePassCreateTableDlg.Create(Self, Db);
Try
if SqlitePassCreateTableDlg.ShowModal = mrOk then
   begin
   ShowMessage('Table ' + SqlitePassCreateTableDlg.EditTableName.Text + ' was created.');
   ActionDatabaseRefreshExecute (Sender);
   TreeViewSelectByName(SqlitePassCreateTableDlg.EditTableName.Text);
   end;
finally
SqlitePassCreateTableDlg.Free;
end;
end;

procedure TMainForm.ActionTableModifyExecute(Sender: TObject);
var
TableDef: TSqlitePassTableDef;
i: Integer;
begin
ShowMessage('This feature is not fully implemented. Some fields information are not correctly retreived from table. '+
            'You will have to complete it manually or directly edit the SQL statement...');

SqlitePassCreateTableDlg := TSqlitePassCreateTableDlg.Create(Self, Db);
Try
TableDef := Db.TableDefs.TableByName(Tv.Selected.Text);
SqlitePassCreateTableDlg.EditTableName.Text := Tv.Selected.Text;
SqlitePassCreateTableDlg.EditTableName.Enabled := False;
for i := 0 to Pred(TableDef.FieldDefs.Count) do
    begin
    TEdit(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('EditFieldName')).Text := TableDef.FieldDefs[i].FieldName;
    TComboBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbDataType')).ItemIndex := TComboBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbDataType')).Items.IndexOf(TableDef.FieldDefs[i].NativeDataType);
    TEdit(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('EditFieldSize')).Text := IntToStr(TableDef.FieldDefs[i].Size);
    TEdit(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('EditFieldPrecision')).Text := IntToStr(TableDef.FieldDefs[i].Precision);
    TComboBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbDefaultValue')).Text := TableDef.FieldDefs[i].DefaultValue;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbPrimaryKey')).Checked := TableDef.FieldDefs[i].PrimaryKey;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbAutoInc')).Checked := TableDef.FieldDefs[i].AutoInc;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbNotNull')).Checked := TableDef.FieldDefs[i].NotNull;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbUnique')).Checked := TableDef.FieldDefs[i].Unique;
    SqlitePassCreateTableDlg.CtrlGrid.Append;
    end;
SqlitePassCreateTableDlg.CtrlGrid.Delete;
SqlitePassCreateTableDlg.CtrlGrid.First;
SqlitePassCreateTableDlg.MemoSQL.Text := TableDef.Sql;
SqlitePassCreateTableDlg.LabelManualSQL.Visible := True;
if SqlitePassCreateTableDlg.ShowModal = mrOk then
   begin
   Db.Engine.Transaction.Start;
   Db.Engine.Transaction.Commit;
//   Db.Engine.ExecSQL();
(*CREATE TEMPORARY TABLE t1_backup(a,b);
INSERT INTO t1_backup SELECT a,b FROM t1;
DROP TABLE t1;
CREATE TABLE t1(a,b);
INSERT INTO t1 SELECT a,b FROM t1_backup;
DROP TABLE t1_backup;
COMMIT*);

   ShowMessage('Table ' + SqlitePassCreateTableDlg.EditTableName.Text + ' was modified.');
   end;
finally
SqlitePassCreateTableDlg.Free;
end;
end;

procedure TMainForm.ActionTableRenameExecute(Sender: TObject);
var
TableName: String;
begin
TableName := Tv.Selected.Text;
FormRenameItem := TFormRenameItem.Create(Self);
try
FormRenameItem.LabelRenameItem.Caption := 'Rename table ' + TableName + ' as :';
if FormRenameItem.ShowModal = mrOk then
   begin
   Db.TableDefs.TableByName(TableName).RenameAs(FormRenameItem.EditNewName.Text);
   ActionDatabaseRefreshExecute(Sender);
   TreeViewSelectByName(FormRenameItem.EditNewName.Text);
   RefreshTreeView(FormRenameItem.EditNewName.Text);   
   end;
finally
FormRenameItem.Free;
end;
end;

procedure TMainForm.TreeViewSelectByName(ItemName: String);
var
i: Integer;
begin
if ItemName = '' then Exit;
For i := 0 to Pred(Tv.Items.Count) do
   if Tv.Items[i].Text = ItemName then
      begin
      Tv.Selected := Tv.Items[i];
      Break;
      end;
end;

procedure TMainForm.ActionTableReindexExecute(Sender: TObject);
begin
   Db.TableDefs.TableByName(Tv.Selected.Text).Reindex;
   ShowMessage('Table ' + Tv.Selected.Text + ' is reindexed.');
end;

procedure TMainForm.ActionTableDeleteExecute(Sender: TObject);
var
CurrentItemIndex: Integer;
begin
if MessageDlg('Do you really want to delete the table : ' + Tv.Selected.Text + ' ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
   begin
   CurrentItemIndex := Tv.Selected.AbsoluteIndex;
   Db.TableDefs.DeleteTable(Tv.Selected.Text);
   ActionDatabaseRefreshExecute(Sender);
   Tv.Selected := Tv.Items[CurrentItemIndex];
   end;
end;

procedure TMainForm.TsDatabaseShow(Sender: TObject);
begin
 SbDbApplyChanges.Enabled := False;
 SbDbCancelChanges.Enabled := False;
end;

procedure TMainForm.CbDbShowSystemObjectsClick(Sender: TObject);
begin
 SbDbApplyChanges.Enabled := True;
 SbDbCancelChanges.Enabled := True;
end;

procedure TMainForm.SbDbApplyChangesClick(Sender: TObject);
begin
Db.QueryTimeout := StrToInt(EditDbQueryTimeout.Text);
Db.UserTag := StrToInt(EditDbUserTag.Text);

//Db.ShowSystemObjects := CbDbShowSystemObjects.Checked
//CbDbReadOnly.Checked := Db.ReadOnly;
//CbDbSmartOpen.Checked := Db.SmartOpen;

{ Options }
Db.Options.CacheSize := StrToInt(EditDbCacheSize.Text);
Db.Options.CountChanges := CbDbCountChanges.Checked;
Db.Options.CaseSensitiveLike := CbDbCaseSensitiveLike.Checked;
Db.Options.EmptyResultCallback := CbDbEmptyResultCallback.Checked;
Db.Options.FullColumnNames := CbDbFullColumnName.Checked;
Db.Options.AutoVacuum := CbDbVacuumType.ItemIndex;
//EditDbTemporaryStorage.Text := '';
{ Synchronous }

end;

procedure TMainForm.EditDbQueryTimeoutKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Not (Key in [#8, '0'..'9']) then Key := #0;
end;

procedure TMainForm.ActionTableEmptyExecute(Sender: TObject);
begin
if MessageDlg('Do you really want to remove all the data from the table : ' + Tv.Selected.Text + ' ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
   begin
   Db.TableDefs.EmptyTable(Tv.Selected.Text);
   SbDatasetRefresh.Click;
   end;
end;

procedure TMainForm.SbSaveSQLToDatabaseClick(Sender: TObject);
begin
if LabelSQLStmtName.Caption = ''
   then begin
   FormRenameItem := TFormRenameItem.Create(Self);
   FormRenameItem.LabelRenameItem.Caption := 'Enter the SQL Statement Name : ';
   if FormRenameItem.ShowModal = mrOk
      then Db.SQLStmts.CreateSQLStmt(FormRenameItem.EditNewName.Text, TStringList(MemoSQLStmt.Lines));
   FormRenameItem.Free;
   end
   else Db.SQLStmts.CreateSQLStmt(LabelSQLStmtName.Caption, TStringList(MemoSQLStmt.Lines));
RefreshTreeView;
end;


procedure TMainForm.ActionSQLStmtCreateNewExecute(Sender: TObject);
begin
if MemoSQLStmt.Lines.Count > 0
   then if MessageDlg('Do you really want to clear the current SQL statement ? ', mtWarning, [mbYes, mbNo], 0) = mrYes then
           begin
           LabelSQLStmtName.Caption := '';
           MemoSQLStmt.Clear;
           end;
PageControl.Pages[0].Tabvisible := False;
PageControl.Pages[1].Tabvisible := False;
PageControl.Pages[2].Tabvisible := True;
MemoSQLStmt.SetFocus;
end;

procedure TMainForm.ActionSQLStmtDeleteExecute(Sender: TObject);
var
CurrentItemIndex: Integer;
begin
if MessageDlg('Do you really want to delete the ' + Tv.Selected.Text + ' SQL statement ? ', mtWarning, [mbYes, mbNo], 0) = mrYes then
           begin
           CurrentItemIndex := Tv.Selected.AbsoluteIndex;
           MemoSQLStmt.Clear;
           Db.SQLStmts.DeleteSQLStmt(Tv.Selected.Text);
           LabelSQLStmtName.Caption := '';
           RefreshTreeView;
           Tv.Selected := Tv.Items[CurrentItemIndex];
           end;
end;

procedure TMainForm.ActionSQLStmtRenameExecute(Sender: TObject);
var
SQLStmtName: String;
begin
SQLStmtName := Tv.Selected.Text;
FormRenameItem := TFormRenameItem.Create(Self);
try
FormRenameItem.LabelRenameItem.Caption := 'Rename SQL statement ' + SQLStmtName + ' as :';
if FormRenameItem.ShowModal = mrOk then
   begin
   Db.SQLStmts.RenameSQLStmt(SQLStmtName, FormRenameItem.EditNewName.Text);
   RefreshTreeView;
   TreeViewSelectByName(FormRenameItem.EditNewName.Text);
   end;
finally
FormRenameItem.Free;
end;
end;

procedure TMainForm.ActionTableSaveAsViewExecute(Sender: TObject);
begin
FormRenameItem := TFormRenameItem.Create(Self);
FormRenameItem.LabelRenameItem.Caption := 'Enter the view name : ';
if FormRenameItem.ShowModal = mrOk then
   begin
   Db.Views.CreateView(FormRenameItem.EditNewName.Text, MemoSqlSelectStmt.Text);
   RefreshTreeView;
   end;
FormRenameItem.Free;
end;

procedure TMainForm.SbSaveSQLAsViewClick(Sender: TObject);
begin
FormRenameItem := TFormRenameItem.Create(Self);
FormRenameItem.LabelRenameItem.Caption := 'Enter the view name : ';
if FormRenameItem.ShowModal = mrOk then
   begin
   Db.Views.CreateView(FormRenameItem.EditNewName.Text, MemoSqlStmt.Text);
   RefreshTreeView;
   end;
FormRenameItem.Free;
end;

procedure TMainForm.ActionViewCreateNewExecute(Sender: TObject);
begin
 ActionSQLStmtCreateNewExecute(Sender);
end;

procedure TMainForm.ActionViewDeleteExecute(Sender: TObject);
begin
 Db.Views.DeleteView(Tv.Selected.Text);
 RefreshTreeView;
end;

procedure TMainForm.SbSaveSQLToFileClick(Sender: TObject);
begin
If SaveFileDialog.Execute
   then MemoSQLStmt.Lines.SaveToFile(SaveFileDialog.Filename);
end;

procedure TMainForm.SbLoadSQLfromFileClick(Sender: TObject);
begin
if OpenFileDialog.Execute
   then MemoSQLStmt.Lines.LoadFromFile(OpenFileDialog.FileName);
end;

procedure TMainForm.ActionSQLExecuteExecute(Sender: TObject);
begin
SQLDirectDataset.Close;
SQLDirectDataset.SQL.Clear;
SQLDirectDataset.SQL := TStringList(MemoSqlStmt.Lines);
PanelSQLResult.Visible := (SQLDirectDataset.SQLSelectStmt.SQLType = stSelect);

if PanelSQLResult.Visible
   then begin
        SQLDirectDataset.Open;
        SQLDirectDataset.SQLSelectStmt.Prepare(SQLDirectDataset.SQL.Text);
        MemoSqlStmt.Lines.Assign(SQLDirectDataset.SQLSelectStmt.SQL);
        end
   else begin
        Db.Engine.ExecSQL(MemoSQLStmt.Lines.Text);
        ActionDatabaseRefreshExecute(Sender);
        end;
end;

procedure TMainForm.SbClosePanelSQLResultClick(Sender: TObject);
begin
 PanelSQLResult.Visible := False;
end;


{ ImageList / Menu / Button Utilities }

procedure TMainForm.ApplicationIdleHandler(Sender: TObject; var Done: Boolean);
begin
 {$IFNDEF FPC}
 RefreshMenuImages;
 {$ENDIF}
 RefreshStatusBar;
 RefreshActions;
 Done := True;
end;

{ The Following procedure are used to ensure correct image display with Delphi 4
  using classic TImageList component }
{$IFNDEF FPC}
procedure TMainForm.InitMenuImages;
var
i: Integer;
Image: TImage;
begin
ImageList.Width := 32;
ImageList.Clear;
Image := TImage.Create(Self);
Image.Picture.Assign(Image10.Picture); { TODO // should be removed, but seems necessary to init picture }
Image.Picture.Bitmap.Height := 16;
Image.Picture.Bitmap.Width := 32;

for i := 0 to Pred(ImageListEnabled.Count) do
    begin
    Image.Picture.Bitmap.Canvas.FillRect(Rect(0,0,32,15));
    ImageListEnabled.Draw(Image.Picture.Bitmap.Canvas,0,0,i);
    if i < ImageListDisabled.Count
       then ImageListDisabled.Draw(Image.Picture.Bitmap.Canvas,16,0,i)
       else ImageListEnabled.Draw(Image.Picture.Bitmap.Canvas,16,0,i);
    ImageList.Add(Image.picture.Bitmap, Image.picture.Bitmap);
    end;

MainActionList.Images := ImageList;
ActionListDatabase.Images := ImageList;
ActionListDataset.Images := ImageList;
ActionListIndexes.Images := ImageList;
ActionListTables.Images := ImageList;
ActionListQueries.Images := ImageList;
ActionListViews.Images := ImageList;
ActionListTriggers.Images := ImageList;
ActionListSQLStmts.Images := ImageList;
end;


function TMainForm.GetMenuItemImage(MenuItem: TMenuItem): Boolean;
var
SpeedButtonBmp, MenuBmp: TBitmap;
DestRect, SourceRect: TRect;
ImageIdx: Integer;
begin

SpeedButtonBmp := TBitmap.Create;
MenuBmp := TBitmap.Create;

try
Result := False;
if MenuItem = nil then Exit;
if (MenuItem.Enabled and (MenuItem.Tag = 1)) or ((MenuItem.Tag = 2) and not MenuItem.Enabled) then Exit;
SpeedButtonBmp.Width := 32;
SpeedButtonBmp.Height := 16;
MenuBmp.Width := 16;
MenuBmp.Height := 16;
DestRect := Rect(0,0,MenuBmp.Width,MenuBmp.Height);

If Assigned(MenuItem.Action) then
   begin
   ImageIdx := TAction(MenuItem.Action).ImageIndex;
   if ImageIdx <> -1 then
      begin
      SpeedButtonBmp.Canvas.Brush.Color := clWhite;
      SpeedButtonBmp.Canvas.Brush.Style := bsSolid;
      SpeedButtonBmp.Canvas.FillRect(DestRect);
      ImageList.GetBitmap(ImageIdx, SpeedButtonBmp);
      if MenuItem.Enabled
         then begin
              SourceRect := Rect(0,0,16,16);
              MenuItem.Tag := 1;
              end
         else begin
              SourceRect := Rect(16,0,32,16);
              MenuItem.Tag := 2;
              end;
      MenuBmp.Canvas.CopyRect(DestRect, SpeedButtonBmp.Canvas, SourceRect);
      MenuItem.Bitmap.Assign(MenuBmp);
      Result := True;
      end;
   end;
finally
MenuBmp.Free;
SpeedButtonBmp.Free;
end;
end;

procedure TMainForm.RefreshMenuImages;
var
i, j: Integer;
SubMenu: TMenuItem;
NeedUpdate: Boolean;
begin
NeedUpdate := False;
MainMenu.Images := nil;
For i := 0 to Pred(MainMenu.Items.Count) do
    begin
    SubMenu := MainMenu.Items[i];
    for j := 0 to Pred(SubMenu.Count)
        do if GetMenuItemImage(SubMenu[j])
              then NeedUpdate := True;
    end;
If NeedUpdate then
   begin
  { Sends a fake Menu change to force Menu
    to display images - One call per menu }
   ActionDatabaseOpen.Visible := False;
   ActionDatabaseOpen.Visible := True;
   ActionTableCreateNew.Visible := False;
   ActionTableCreateNew.Visible := True;
   ActionQueryCreateNew.Visible := False;
   ActionQueryCreateNew.Visible := True;
   ActionViewCreateNew.Visible := False;
   ActionViewCreateNew.Visible := True;
   ActionTriggerCreateNew.Visible := False;
   ActionTriggerCreateNew.Visible := True;
   ActionSQLStmtCreateNew.Visible := False;
   ActionSQLStmtCreateNew.Visible := True;
   end;
end;
{$ENDIF}

{ This procedure is used to avoid manual editing of the Speedbuttons.Glyph property
  every time the MainForm.dfm file is converted to MainForm.lfm }
procedure TMainForm.InitToolbarImages;

 procedure InitButtonImage(Btn: TSpeedButton; BtnAction: TAction);
   begin
    {$IFNDEF FPC}
    Btn.NumGlyphs := 2;
    {$ELSE}
    Btn.NumGlyphs := 1;
    {$ENDIF}
    Btn.Glyph := nil;
    Btn.Action := nil;
    Btn.Action := BtnAction;
   end;
   
begin
 { Database }
 InitButtonImage(SbDatabaseOpen, ActionDatabaseOpen);
 InitButtonImage(SbDatabaseTransactionStart, ActionDatabaseTransactionStart);
 InitButtonImage(SbDatabaseTransactionCommit, ActionDatabaseTransactionCommit);
 InitButtonImage(SbDatabaseTransactionRollback, ActionDatabaseTransactionRollback);
 InitButtonImage(SbDatabaseClose, ActionDatabaseClose);
 InitButtonImage(SbDatabaseAttach, ActionDatabaseAttach);
 InitButtonImage(SbDatabaseDetach, ActionDatabaseDetach);
 InitButtonImage(SbDatabaseCompactSize, ActionDatabaseCompactSize);
 InitButtonImage(SbDatabaseCheckIntegrity, ActionDatabaseCheckIntegrity);
 InitButtonImage(SbDatabaseRefresh, ActionDatabaseRefresh);

 { SQL }
 InitButtonImage(SbDatabaseShowSQLPage, ActionShowSQLPage);

 { Dataset }
 InitButtonImage(SbDatasetRefresh, ActionDatasetRefresh);
 InitButtonImage(SbDatasetShowSortDialog, ActionDatasetShowSortDialog);
 InitButtonImage(SbDatasetFilterOnSelection, ActionDatasetFilterOnSelection);
 InitButtonImage(SbDatasetShowFilterDialog, ActionDatasetShowFilterDialog);
 InitButtonImage(SbDatasetFilterOnOff, ActionDatasetFilterOnOff);
 InitButtonImage(SbDatasetShowLocateDialog, ActionDatasetShowLocateDialog);
 InitButtonImage(SbDatasetLocateFirst, ActionDatasetLocateFirst);
 InitButtonImage(SbDatasetLocatePrior, ActionDatasetLocatePrior);
 InitButtonImage(SbDatasetLocateNext, ActionDatasetLocateNext);
 InitButtonImage(SbDatasetLocateLast, ActionDatasetLocateLast);

 { Indexes }
 InitButtonImage(SbIndexCreateNew, ActionIndexCreateNew);
 InitButtonImage(SbIndexRename, ActionIndexRename);
 InitButtonImage(SbIndexDelete, ActionIndexDelete);
 InitButtonImage(SbIndexRefresh, ActionIndexRefresh);

 { Tables }
(* InitButtonImage(SbTableCreateNew, ActionTableCreateNew);
 InitButtonImage(SbTableModify, ActionTableModify);
 InitButtonImage(SbTableDelete, ActionTableDelete);
 InitButtonImage(SbTableRename, ActionTableRename);
 InitButtonImage(SbTableEmpty, ActionTableEmpty);
 InitButtonImage(SbTableReindex, ActionTableReindex);
 InitButtonImage(SbTableSaveAsView, ActionTableSaveAsView);*)

end;


procedure TMainForm.ActionDatabaseCheckIntegrityExecute(Sender: TObject);
begin
// TODO
ShowMessage('Not implemented !');
end;

procedure TMainForm.PopupMenusPopup(Sender: TObject);
begin
ActionsNeedUpdate := True;
RefreshActions;
end;

initialization
 {$IFDEF FPC}
  {$I SQLitePassDboTest.lrs}
 {$ENDIF}
end.

